<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 2                                                  |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Articles
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminDoAddNewArticle
 * A function to add a new article
 * @author Philipp Louis Esselbach
 */
function AdminDoAddNewArticle()
{
	global $database, $security, $system, $html, $ipaddr, $login_username, $preferences, $uwrapper, $words_articles;
	$input_website = ( isset( $_POST[ 'input_website' ] ) ) ? $security -> checknum( $_POST[ 'input_website' ] ) : "" ;
	$input_article_id = ( isset( $_POST[ 'input_article_id' ] ) ) ? $security -> checknum( $_POST[ 'input_article_id' ] ) : "" ;
	$input_category = ( isset( $_POST[ 'input_category' ] ) ) ? $security -> checknum( $_POST[ 'input_category' ] ) : "" ;
	$input_teaserimage = ( isset( $_POST[ 'input_teaserimage' ] ) ) ? $security -> checknum( $_POST[ 'input_teaserimage' ] ) : 0 ;
	$input_top = ( isset( $_POST[ 'input_top' ] ) ) ? $security -> checknum( $_POST[ 'input_top' ] ) : 0 ;
	$input_year = ( isset( $_POST[ 'input_year' ] ) ) ? $security -> checknum( $_POST[ 'input_year' ] ) : "" ;
	$input_month = ( isset( $_POST[ 'input_month' ] ) ) ? $security -> checknum( $_POST[ 'input_month' ] ) : "" ;
	$input_day = ( isset( $_POST[ 'input_day' ] ) ) ? $security -> checknum( $_POST[ 'input_day' ] ) : "" ;
	$input_hour = ( isset( $_POST[ 'input_hour' ] ) ) ? $security -> checknum( $_POST[ 'input_hour' ] ) : "" ;
	$input_minute = ( isset( $_POST[ 'input_minute' ] ) ) ? $security -> checknum( $_POST[ 'input_minute' ] ) : "" ;
	$input_second = ( isset( $_POST[ 'input_second' ] ) ) ? $security -> checknum( $_POST[ 'input_second' ] ) : "" ;
	$input_now = ( isset( $_POST[ 'input_now' ] ) ) ? $security -> checknum( $_POST[ 'input_now' ] ) : "" ;
	$input_expire_year = ( isset( $_POST[ 'input_expire_year' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_year' ] ) : "" ;
	$input_expire_month = ( isset( $_POST[ 'input_expire_month' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_month' ] ) : "" ;
	$input_expire_day = ( isset( $_POST[ 'input_expire_day' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_day' ] ) : "" ;
	$input_expire_hour = ( isset( $_POST[ 'input_expire_hour' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_hour' ] ) : "" ;
	$input_expire_minute = ( isset( $_POST[ 'input_expire_minute' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_minute' ] ) : "" ;
	$input_expire_second = ( isset( $_POST[ 'input_expire_second' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_second' ] ) : "" ;
	$input_expire_never = ( isset( $_POST[ 'input_expire_never' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_never' ] ) : 0 ;
	$input_article_title = ( isset( $_POST[ 'input_article_title' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_title' ] ) : "" ;
	$input_article_seo = ( isset( $_POST[ 'input_article_seo' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_seo' ] ) : "" ;
	$input_article_description = ( isset( $_POST[ 'input_article_description' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_description' ] ) : "" ;
	$input_article_keywords = ( isset( $_POST[ 'input_article_keywords' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_keywords' ] ) : "" ;
	$input_article_summary = ( isset( $_POST[ 'input_article_summary' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_summary' ] ) : "" ;
	$input_article_tags = ( isset( $_POST[ 'input_article_tags' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_tags' ] ) : "" ;
	$input_article_pagetitle = ( isset( $_POST[ 'input_article_pagetitle' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_pagetitle' ] ) : "" ;
	$input_article_pagetext = ( isset( $_POST[ 'input_article_pagetext' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_pagetext' ] ) : "" ;
	$input_forum = ( isset( $_POST[ 'input_forum' ] ) ) ? $security -> checknum( $_POST[ 'input_forum' ] ) : "" ;
	$input_html = ( isset( $_POST[ 'input_html' ] ) ) ? $security -> checknum( $_POST[ 'input_html' ] ) : "" ;
	$input_smilies = ( isset( $_POST[ 'input_smilies' ] ) ) ? $security -> checknum( $_POST[ 'input_smilies' ] ) : "" ;
	$input_blockcode = ( isset( $_POST[ 'input_blockcode' ] ) ) ? $security -> checknum( $_POST[ 'input_blockcode' ] ) : "" ;
	$input_allow_comments = ( isset( $_POST[ 'input_allow_comments' ] ) ) ? $security -> checknum( $_POST[ 'input_allow_comments' ] ) : "" ;
	$input_frontpage = ( isset( $_POST[ 'input_frontpage' ] ) ) ? $security -> checknum( $_POST[ 'input_frontpage' ] ) : 0 ;
	$input_url_tag = ( isset( $_POST[ 'input_url_tag' ] ) ) ? $security -> checknum( $_POST[ 'input_url_tag' ] ) : "" ;
	$input_url_get = ( isset( $_POST[ 'input_url_get' ] ) ) ? $security -> checknum( $_POST[ 'input_url_get' ] ) : "" ;
	$input_status = ( isset( $_POST[ 'input_status' ] ) ) ? $security -> checknum( $_POST[ 'input_status' ] ) : "" ;
	$input_password = ( isset( $_POST[ 'input_password' ] ) ) ? $security -> checkvar( $_POST[ 'input_password' ] ) : "" ;
	$input_fields = ( isset( $_POST[ 'input_fields' ] ) ) ? $security -> checkvararray( $_POST[ 'input_fields' ] ) : "" ;
	$input_doupload = ( isset( $_POST[ 'input_doupload' ] ) ) ? $security -> checkvar( $_POST[ 'input_doupload' ] ) : "" ;
	$input_doteaserupload = ( isset( $_POST[ 'input_doteaserupload' ] ) ) ? $security -> checkvar( $_POST[ 'input_doteaserupload' ] ) : "" ;
	$input_file_title = ( isset( $_POST[ 'input_file_title' ] ) ) ? $security -> checkvararray( $_POST[ 'input_file_title' ] ) : array() ;
	$input_file_description = ( isset( $_POST[ 'input_file_description' ] ) ) ? $security -> checkvararray( $_POST[ 'input_file_description' ] ) : array() ;
	$input_dofileremove = ( isset( $_POST[ 'input_dofileremove' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileremove' ] ) : "" ;
	$input_dofileedit = ( isset( $_POST[ 'input_dofileedit' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileedit' ] ) : "" ;
	$input_doeditfile = ( isset( $_POST[ 'input_doeditfile' ] ) ) ? $security -> checkvar( $_POST[ 'input_doeditfile' ] ) : "" ;
	$input_edittitle = ( isset( $_POST[ 'input_edittitle' ] ) ) ? $security -> checkvar( $_POST[ 'input_edittitle' ] ) : "" ;
	$input_editdescription = ( isset( $_POST[ 'input_editdescription' ] ) ) ? $security -> checkvar( $_POST[ 'input_editdescription' ] ) : "" ;
	$input_editid = ( isset( $_POST[ 'input_editid' ] ) ) ? $security -> checknum( $_POST[ 'input_editid' ] ) : "" ;
	$input_dopreview = ( isset( $_POST[ 'input_dopreview' ] ) ) ? $security -> checkvar( $_POST[ 'input_dopreview' ] ) : "" ;
	$input_dospellcheck = ( isset( $_POST[ 'input_dospellcheck' ] ) ) ? $security -> checkvar( $_POST[ 'input_dospellcheck' ] ) : "" ;
	$input_doaddpage = ( isset( $_POST[ 'input_doaddpage' ] ) ) ? $security -> checkvar( $_POST[ 'input_doaddpage' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $system -> adminhashget() != $input_security_hash ) and( $preferences[ 'website_subsessions_admin' ] ) )
	{
		$html -> login( $words_articles[ 'ERROR' ], $words_articles[ 'INVALID_SESSION' ], "index.php" );
		exit;
	}
	
	$notice = "";
	
	if( $input_doupload )
	{
		$error = "";
		
		for( $a = 0; $a < count( $_FILES[ 'input_file' ][ 'name' ] ); $a++ )
		{
			$file_name = ( isset( $_FILES[ 'input_file' ][ 'name' ][ $a ] ) ) ? $security -> checkvar( strtolower( $_FILES[ 'input_file' ][ 'name' ][ $a ] ) ) : "" ;
			$tmp_name = ( isset( $_FILES[ 'input_file' ][ 'tmp_name' ][ $a ] ) ) ? $_FILES[ 'input_file' ][ 'tmp_name' ][ $a ] : "" ;
			$file_size = ( isset( $_FILES[ 'input_file' ][ 'size' ][ $a ] ) ) ? $security -> checknum( $_FILES[ 'input_file' ][ 'size' ][ $a ] ) : "" ;
			$file_type = ( isset( $_FILES[ 'input_file' ][ 'type' ][ $a ] ) ) ? $security -> checkvar( $_FILES[ 'input_file' ][ 'type' ][ $a ] ) : "" ;
			
			if( $file_name )
			{
				$query = $database -> dbquery( "SELECT filetype_adminsize, filetype_extension FROM " . DB_PREFIX . "esselbach_ct_filetypes WHERE filetype_mime = '" . $database -> dbescape( $file_type ) . "'" );
				
				if( $database -> dbrows( $query ) )
				{
					list( $file_allowedsize, $file_extension ) = $database -> dbrow( $query );
					
					if( $file_size > $file_allowedsize )
					{
						$error = $words_articles[ 'FILE_TOO_LARGE' ] . " " . $file_allowedsize . " " . $words_articles[ 'BYTES' ];
					}
					
					if( !preg_match( "/" . $file_extension . "/i", $file_name ) )
					{
						$error = $words_articles[ 'FILETYPE_INVALID' ];
					}
				}
				else
				{
					$error = $words_articles[ 'FILETYPE_UNKNOWN' ];
				}
				
				if( !$tmp_name )
				{
					$error = $words_articles[ 'FILE_EMPTY' ];
				}
				
				if( !$error )
				{
					$file = @fopen( $tmp_name, "r" );
					
					if( $file )
					{
						$binary = fread( $file, filesize( $tmp_name ) );
						
						if( ( $file_type == "image/png" or $file_type == "image/pjpeg" or $file_type == "image/jpeg" or $file_type == "image/gif" ) and	function_exists( "imagecreatefromstring" ) )
						{
							if( $preferences[ 'articles_image_width' ] )
							{
								$binary = $system -> resizeimage( $binary, $file_type, $preferences[ 'articles_image_width' ], $preferences[ 'articles_image_brandtext' ], $preferences[ 'articles_image_brandcolor' ] );
								$file_size = strlen( $binary );
							}
							
							$thumb_image = $system -> resizeimage( $binary, $file_type, $preferences[ 'articles_image_thumbwidth' ], "", "" );
							$thumb_size = strlen( $thumb_image );
							$thumb_image = $database -> dbescape( $thumb_image );
						}
						else
						{
							$thumb_image = "";
							$thumb_size = 0;
						}
						
						$binary = $database -> dbescape( $binary );
						fclose( $file );
						
						if( !$input_file_title[ $a ] )
						{
							$input_file_title[ $a ] = $file_name;
						}
						
						if( !$input_file_description[ $a ] )
						{
							$input_file_description[ $a ] = $words_articles[ 'NO_DESCRIPTION' ];
						}
						
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_articlesfiles (articlefile_id, articlefile_author, articlefile_filename, articlefile_title, articlefile_description, articlefile_mime, articlefile_size, articlefile_binary, articlefile_thumbsize, articlefile_thumbimage, articlefile_inuse, articlefile_page, articlefile_date, articlefile_views, articlefile_activity, articlefile_postip, articlefile_editip) VALUES (NULL, '" . $login_username . "', '" . $file_name . "', '" . $input_file_title[ $a ] . "', '" . $input_file_description[ $a ] . "', '" . $file_type . "', '" . $file_size . "', '" . $binary . "', '" . $thumb_size . "', '" . $thumb_image . "', '0', '0', now(), '0', now(), '" . $ipaddr . "', '" . $ipaddr . "')" );
						$notice = $words_articles[ 'UPLOAD_SUCCESSFULLY' ];
						$input_file_title[ $a ] = "";
						$input_file_description[ $a ] = "";
					}
				}
				else
				{
					$file_id = $a + 1;
					$notice = $words_articles[ 'FILE' ] . " #" . $file_id . ":<br />" . $error;
				}
			}
		}
	}
	
	if( $input_doteaserupload )
	{
		$file_name = ( isset( $_FILES[ 'input_teaserfile' ][ 'name' ] ) ) ? $security -> checkvar( strtolower( $_FILES[ 'input_teaserfile' ][ 'name' ] ) ) : "" ;
		$tmp_name = ( isset( $_FILES[ 'input_teaserfile' ][ 'tmp_name' ] ) ) ? $_FILES[ 'input_teaserfile' ][ 'tmp_name' ] : "" ;
		$file_size = ( isset( $_FILES[ 'input_teaserfile' ][ 'size' ] ) ) ? $security -> checknum( $_FILES[ 'input_teaserfile' ][ 'size' ] ) : "" ;
		$file_type = ( isset( $_FILES[ 'input_teaserfile' ][ 'type' ] ) ) ? $security -> checkvar( $_FILES[ 'input_teaserfile' ][ 'type' ] ) : "" ;
		$query = $database -> dbquery( "SELECT filetype_adminsize, filetype_extension FROM " . DB_PREFIX . "esselbach_ct_filetypes WHERE filetype_mime = '" . $file_type . "' AND filetype_isimage = '1'" );
		
		if( $database -> dbrows( $query ) )
		{
			list( $file_allowedsize, $file_extension ) = $database -> dbrow( $query );
			
			if( $file_size > $file_allowedsize )
			{
				$notice = $words_articles[ 'FILE_TOO_LARGE' ] . " " . $file_allowedsize . " " . $words_articles[ 'BYTES' ];
			}
			
			if( !preg_match( "/" . $file_extension . "/i", $file_name ) )
			{
				$notice = $words_articles[ 'FILETYPE_INVALID' ];
			}
		}
		else
		{
			$notice = $words_articles[ 'FILETYPE_NOT_ALLOWED_IMAGE' ];
		}
		
		if( !$tmp_name )
		{
			$notice = $words_articles[ 'FILE_EMPTY' ];
		}
		
		$file = @fopen( $tmp_name, "r" );
		
		if( $file )
		{
			$binary = fread( $file, filesize( $tmp_name ) );
			
			if( ( $file_type == "image/png" or $file_type == "image/pjpeg" or $file_type == "image/jpeg" or $file_type == "image/gif" ) and function_exists( "imagecreatefromstring" ) )
			{
				if( $preferences[ 'articles_image_teaserwidth' ] )
				{
					$teaserwidth = $preferences[ 'articles_image_teaserwidth' ];
				}
				else
				{
					$teaserwidth = 20;
				}
				
				$teaser_image = $system -> resizeimage( $binary, $file_type, $teaserwidth, "", "" );
				$teaser_size = strlen( $teaser_image );
				$teaser_image = $database -> dbescape( $teaser_image );
			}
			else
			{
				$teaser_size = $file_size;
				$teaser_image = $database -> dbescape( $binary );
			}
			
			fclose( $file );
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_articlesteaserimages (articleteaserimage_id, articleteaserimage_author, articleteaserimage_filename, articleteaserimage_mime, articleteaserimage_size, articleteaserimage_binary, articleteaserimage_default, articleteaserimage_article, articleteaserimage_ip) VALUES (NULL, '" . $login_username . "', '" . $file_name . "', '" . $file_type . "', '" . $teaser_size . "', '" . $teaser_image . "', '0', '0', '" . $ipaddr . "')" );
			$notice = $words_articles[ 'TEASER_IMAGE_ADDED' ];
		}
	}
	
	if( $input_dofileremove )
	{
		$input_file = explode( "#", $input_dofileremove );
		$input_file = $security -> checknum( $input_file[ 1 ] );
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_articlesfiles WHERE articlefile_author = '" . $login_username . "' AND articlefile_id = '" . $input_file . "'" );
		$notice = $words_articles[ 'FILE_REMOVED' ];
	}
	
	if( $input_article_id )
	{
		$query = $database -> dbquery( "SELECT article_id FROM " . DB_PREFIX . "esselbach_ct_articles WHERE article_id = '" . $input_article_id . "'" );
		
		if( !$database -> dbrows( $query ) )
		{
			$notice = $words_articles[ 'INVALID_ARTICLE' ];
		}
	}
	
	if( !$notice and !$input_article_id )
	{
		if( !$input_article_title )
		{
			$notice = $words_articles[ 'ARTICLE_NO_TITLE' ];
		}
		
		if( !$input_article_summary )
		{
			$notice = $words_articles[ 'ARTICLE_NO_SUMMARY' ];
		}
		
		if( !$input_article_pagetext )
		{
			$notice = $words_articles[ 'ARTICLE_NO_TEXT' ];
		}
		
		if( $preferences[ 'articles_start_expire_date' ] )
		{
			if( !checkdate( $input_month, $input_day, $input_year ) or !checkdate( $input_expire_month, $input_expire_day, $input_expire_year ) )
			{
				$notice = $words_articles[ 'INVALID_DATE' ];
			}
		}
		
		if( ( $input_status == 3 ) and( !$input_password ) )
		{
			$notice = $words_articles[ 'NO_PASSWORD' ];
		}
	}
	
	if( $input_dofileedit )
	{
		$notice = "";
	}
	
	if( $input_doeditfile )
	{
		if( !$input_edittitle )
		{
			$query = dbquery( "SELECT articlefile_filename FROM " . DB_PREFIX . "esselbach_ct_articlesfiles WHERE articlefile_id = '" . $input_editid . "'" );
			list( $input_edittitle ) = $database -> dbquery( $query );
			$input_edittitle = $database -> dbescape( $input_edittitle );
		}
		
		if( !$input_editdescription )
		{
			$input_editdescription = $words_articles[ 'NO_DESCRIPTION' ];
		}
		
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articlesfiles SET articlefile_title = '" . $input_edittitle . "', articlefile_description = '" . $input_editdescription . "', articlefile_editip = '" . $ipaddr . "' WHERE articlefile_author = '" . $login_username . "' AND articlefile_id = '" . $input_editid . "'" );
		$notice = $words_articles[ 'DESCRIPTION_CHANGED' ];
	}
	
	if( !$input_article_description and !$input_article_id )
	{
		$input_article_description = $system -> description( $input_article_summary );
	}
	
	if( !$input_article_keywords and !$input_article_id )
	{
		$input_article_keywords = $system -> keywords( $input_article_summary );
	}
	
	if( $input_dospellcheck )
	{
		$dictionary = pspell_new( $preferences[ 'website_spellchecker' ] );
		$words_array = explode( " ", $input_article_pagetext );
		$input_page_spelling = "";
		$input_spell_errors = 0;
		
		foreach( $words_array as $word )
		{
			if( pspell_check( $dictionary, $word ) )
			{
				$input_page_spelling .= $word . " ";
			}
			else
			{
				$suggestions = implode( ", ", pspell_suggest( $dictionary, $word ) );
				( $suggestions ) ? $suggestions = $words_articles[ 'SUGGESTIONS' ] . ": " . $suggestions : $suggestions = $words_articles[ 'NO_SUGGESTIONS' ];
				$input_page_spelling .= "<span style=\"background-color: rgb(235, 15, 20); font-weight:bold;\" title=\"" . $suggestions . "\"><strong>" . $word . "</strong></span> ";
				$input_spell_errors++;
			}
			
			$input_page_spelling .= $word . " ";
		}
		
		$notice = $words_articles[ 'THE_SPELL_CHECKER_FOUND' ] . " " . $input_spell_errors . " " . $words_articles[ 'ERRORS' ] . ":<br /><br />" . $input_page_spelling;
	}
	
	if( ( $notice ) or( $input_dopreview ) or( $input_dofileedit ) )
	{
		AdminAddNewArticle( 0, $notice );
	}
	else
	{
		$seo_url = ( $preferences[ 'website_mod_rewrite' ] ) ? "" : "contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] ;
		if( is_array( $input_fields ) )
		{
			$input_fields_encoded = base64_encode( $system -> stripthis( $input_fields[ 0 ] ) );
			
			for( $i = 1; $i < 24; $i++ )
			{
				$input_fields_encoded .= "|";
				
				if( isset( $input_fields[ $i ] ) )
				{
					$input_fields_encoded .= base64_encode( $system -> stripthis( $input_fields[ $i ] ) );
				}
			}
		}
		else
		{
			$input_fields_encoded = "";
		}
		
		if ( $input_blockcode )
		{
			if ( $input_url_tag )
			{
				$input_article_summary = preg_replace( "#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1[url]\\2[/url]", $input_article_summary );
				$input_article_pagetext = preg_replace( "#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1[url]\\2[/url]", $input_article_pagetext );	
			}
				
			if ( $input_url_get )
			{
				$input_article_summary = $system -> geturltitles( $input_article_summary );
				$input_article_pagetext = $system -> geturltitles( $input_article_pagetext );
			}
		}
		
		$input_article_summary_parsed = stripslashes( $input_article_summary );
		$input_article_pagetext_parsed = stripslashes( $input_article_pagetext );
		
		if( !$input_html )
		{
			$input_article_summary_parsed = $system -> dechomp( $input_article_summary_parsed );
			$input_article_pagetext_parsed = $system -> dechomp( $input_article_pagetext_parsed );
		}
		else
		{
			$input_article_summary_parsed = $system -> scriptex( $input_article_summary_parsed );
			$input_article_pagetext_parsed = $system -> scriptex( $input_article_pagetext_parsed );
		}
		
		if( $input_smilies )
		{
			$input_article_summary_parsed = $system -> smilies( $input_article_summary_parsed );
			$input_article_pagetext_parsed = $system -> smilies( $input_article_pagetext_parsed );
		}
		
		if( $input_blockcode )
		{
			$input_article_summary_parsed = $system -> code( $input_article_summary_parsed );
			$input_article_pagetext_parsed = $system -> code( $input_article_pagetext_parsed );
			$input_article_pagetext_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=articles&amp;action=attachments&amp;id=\\1\">\\2</a>", $input_article_pagetext_parsed );
			$input_article_pagetext_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=articles&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_article_pagetext_parsed );
			$input_article_pagetext_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"" . $seo_url . "articles" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\" title=\"" . $words_articles[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"contentteller.php?ct=articles&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_article_pagetext_parsed );
		}
		
		$input_article_summary_parsed = $database -> dbescape( $input_article_summary_parsed );
		$input_article_pagetext_parsed = $database -> dbescape( $input_article_pagetext_parsed );
		
		if( $preferences[ 'articles_start_expire_date' ] )
		{
			if( $input_now )
			{
				$input_startdate = date( "Y-m-d H:i:s", mktime() );
			}
			else
			{
				$input_startdate = date( "Y-m-d H:i:s", mktime( $input_hour, $input_minute, $input_second, $input_month, $input_day, $input_year ) );
			}
			
			$input_expiredate = date( "Y-m-d H:i:s", mktime( $input_expire_hour, $input_expire_minute, $input_expire_second, $input_expire_month, $input_expire_day, $input_expire_year ) );
		}
		else
		{
			$input_startdate = date( "Y-m-d H:i:s", mktime() );
			$input_expiredate = date( "Y-m-d H:i:s", mktime() );
			$input_expire_never = 1;
		}
		
		if( $input_article_id )
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articles SET article_pages = article_pages + 1 WHERE article_id = '" . $input_article_id . "'" );
			$query = $database -> dbquery( "SELECT articlepage_page FROM " . DB_PREFIX . "esselbach_ct_articlespages WHERE articlepage_article = '" . $input_article_id . "' ORDER by articlepage_page DESC LIMIT 1" );
			list( $input_article_page ) = $database -> dbrow( $query );
			$input_article_page++;
		}
		else
		{
			$input_article_title = htmlspecialchars( $input_article_title );
			$input_article_seo = $system -> doseo( $input_article_title );
			$query = $database -> dbquery( "SELECT COUNT(article_id) FROM " . DB_PREFIX . "esselbach_ct_articles WHERE article_seo = '" . $input_article_seo . "'" );
			list( $seo_articles ) = $database -> dbrow( $query );
			
			if( $seo_articles )
			{
				$input_article_seo .= "_" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
			}
			
			if( !$input_article_tags and $preferences[ 'articles_automated_tags' ] )
			{
				$input_article_tags = $system -> tags( $input_article_title );
			}
			
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_articles (article_id, article_author, article_website, article_category, article_title, article_seo, article_rawsummary, article_summary, article_pages, article_description, article_keywords, article_tags, article_teaser, article_comments, article_allowcomments, article_thread, article_frontpage, article_html, article_smilies, article_code, article_status, article_password, article_date, article_startdate, article_expiredate, article_neverexpire, article_fields, article_sticky, article_views, article_rating, article_votes, article_activity, article_postip, article_editip, article_editadmin) VALUES (NULL, '" . $login_username . "', '" . $input_website . "', '" . $input_category . "', '" . $input_article_title . "', '" . $input_article_seo . "', '" . $input_article_summary . "', '" . $input_article_summary_parsed . "', '1', '" . $input_article_description . "', '" . $input_article_keywords . "', '" . $input_article_tags . "', '" . $input_teaserimage . "', '0', '" . $input_allow_comments . "', '0', '" . $input_frontpage . "', '" . $input_html . "', '" . $input_smilies . "', '" . $input_blockcode . "', '" . $input_status . "', '" . $input_password . "', now(), '" . $input_startdate . "', '" . $input_expiredate . "', '" . $input_expire_never . "', '" . $input_fields_encoded . "', '" . $input_top . "', '0', '0', '0', now(), '" . $ipaddr . "', '" . $ipaddr . "', '" . $login_username . "')" );
			$input_article_id = $database -> dblastinsert();
			$input_article_page = 1;
			
			if( $preferences[ 'articles_forum_comments' ] )
			{
				if( $input_forum )
				{
					$link = $preferences[ 'website_url' ] . "/" . $seo_url . "articles" . $preferences[ 'param_action' ] . "summary" . $preferences[ 'param_page' ] . $input_article_seo . ".html";
					
					if( $preferences[ 'website_uwrapper_loginname' ] )
					{
						$query = $database -> dbquery( "SELECT user_loginname FROM " . DB_PREFIX . "esselbach_ct_users WHERE user_name = '" . $login_username . "' AND user_status = '2'" );
						list( $loginname ) = $database -> dbrow( $query );
						$userid = $uwrapper -> getuserid( $loginname );
						$threadid = $uwrapper -> addthread( $input_article_title, $input_article_description, $link, $input_forum, $loginname, $userid );
					}
					else
					{
						$userid = $uwrapper -> getuserid( $login_username );
						$threadid = $uwrapper -> addthread( $input_article_title, $input_article_description, $link, $input_forum, $login_username, $userid );
					}
					
					$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articles SET article_thread = '" . $threadid . "' WHERE article_id = '" . $input_article_id . "'" );
					
					if( $userid )
					{
						$uwrapper -> addpost( $login_username );
					}
				}
			}
			
			if( $input_article_tags )
			{
				$tags = explode( ",", $input_article_tags );
				
				foreach( $tags as $tag )
				{
					$tag_seo = $system -> doseo( $tag );
					$query = $database -> dbquery( "SELECT articletag_id FROM " . DB_PREFIX . "esselbach_ct_articlestags WHERE articletag_tag = '" . $tag . "' AND (articletag_website = '0' AND articletag_website = '" . $input_website . "')" );
					
					if( $database -> dbrows( $query ) )
					{
						$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articlestags SET articletag_count = articletag_count + 1, articletag_date = now() WHERE articletag_tag = '" . $tag . "' AND (articletag_website = '0' AND articletag_website = '" . $input_website . "')" );
					}
					else
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_articlestags (articletag_id, articletag_website, articletag_tag, articletag_seo, articletag_count, articletag_date) VALUES (NULL, '" . $input_website . "', '" . $tag . "', '" . $tag_seo . "', '1', now())" );
					}
				}
			}
		}
		
		$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_articlespages (articlepage_id, articlepage_article, articlepage_page, articlepage_title, articlepage_rawtext, articlepage_text, articlepage_postip, articlepage_editip, articlepage_editadmin) VALUES (NULL, '" . $input_article_id . "', '" . $input_article_page . "', '" . $input_article_pagetitle . "', '" . $input_article_pagetext . "', '" . $input_article_pagetext_parsed . "', '" . $ipaddr . "', '" . $ipaddr . "', '" . $login_username . "')" );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articlesfiles SET articlefile_inuse = '1', articlefile_page = '" . $input_article_page . "', articlefile_activity = now(), articlefile_editip = '" . $ipaddr . "' WHERE articlefile_author = '" . $login_username . "' AND articlefile_inuse = '0'" );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articlesteaserimages SET articleteaserimage_article = '" . $input_article_id . "' WHERE articleteaserimage_author = '" . $login_username . "' AND articleteaserimage_article = '0' AND articleteaserimage_default = '0'" );
		
		if( $input_doaddpage )
		{
			AdminAddNewArticle( $input_article_id, 0 );
		}
		else
		{
			$html -> login( $words_articles[ 'ADD_NEW_ARTICLE' ], $words_articles[ 'ARTICLE_ADDED' ], "index.php?action=managearticles" );
		}
	}
}
?>