<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 2                                                  |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Articles
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminDoEditArticle
 * A function to edit an existing article
 * @author Philipp Louis Esselbach
 */
function AdminDoEditArticle()
{
	global $database, $security, $system, $html, $ipaddr, $wysiwyg, $login_username, $preferences, $words_articles;
	$input_website = ( isset( $_POST[ 'input_website' ] ) ) ? $security -> checknum( $_POST[ 'input_website' ] ) : "" ;
	$input_category = ( isset( $_POST[ 'input_category' ] ) ) ? $security -> checknum( $_POST[ 'input_category' ] ) : "" ;
	$input_teaserimage = ( isset( $_POST[ 'input_teaserimage' ] ) ) ? $security -> checknum( $_POST[ 'input_teaserimage' ] ) : 0 ;
	$input_top = ( isset( $_POST[ 'input_top' ] ) ) ? $security -> checknum( $_POST[ 'input_top' ] ) : 0 ;
	$input_year = ( isset( $_POST[ 'input_year' ] ) ) ? $security -> checknum( $_POST[ 'input_year' ] ) : "" ;
	$input_month = ( isset( $_POST[ 'input_month' ] ) ) ? $security -> checknum( $_POST[ 'input_month' ] ) : "" ;
	$input_day = ( isset( $_POST[ 'input_day' ] ) ) ? $security -> checknum( $_POST[ 'input_day' ] ) : "" ;
	$input_hour = ( isset( $_POST[ 'input_hour' ] ) ) ? $security -> checknum( $_POST[ 'input_hour' ] ) : "" ;
	$input_minute = ( isset( $_POST[ 'input_minute' ] ) ) ? $security -> checknum( $_POST[ 'input_minute' ] ) : "" ;
	$input_second = ( isset( $_POST[ 'input_second' ] ) ) ? $security -> checknum( $_POST[ 'input_second' ] ) : "" ;
	$input_now = ( isset( $_POST[ 'input_now' ] ) ) ? $security -> checknum( $_POST[ 'input_now' ] ) : "" ;
	$input_expire_year = ( isset( $_POST[ 'input_expire_year' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_year' ] ) : "" ;
	$input_expire_month = ( isset( $_POST[ 'input_expire_month' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_month' ] ) : "" ;
	$input_expire_day = ( isset( $_POST[ 'input_expire_day' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_day' ] ) : "" ;
	$input_expire_hour = ( isset( $_POST[ 'input_expire_hour' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_hour' ] ) : "" ;
	$input_expire_minute = ( isset( $_POST[ 'input_expire_minute' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_minute' ] ) : "" ;
	$input_expire_second = ( isset( $_POST[ 'input_expire_second' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_second' ] ) : "" ;
	$input_expire_never = ( isset( $_POST[ 'input_expire_never' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_never' ] ) : "" ;
	$input_article_title = ( isset( $_POST[ 'input_article_title' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_title' ] ) : "" ;
	$input_article_seo = ( isset( $_POST[ 'input_article_seo' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_seo' ] ) : "" ;
	$input_article_description = ( isset( $_POST[ 'input_article_description' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_description' ] ) : "" ;
	$input_article_keywords = ( isset( $_POST[ 'input_article_keywords' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_keywords' ] ) : "" ;
	$input_article_summary = ( isset( $_POST[ 'input_article_summary' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_summary' ] ) : "" ;
	$input_article_tags = ( isset( $_POST[ 'input_article_tags' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_tags' ] ) : "" ;
	$input_html = ( isset( $_POST[ 'input_html' ] ) ) ? $security -> checknum( $_POST[ 'input_html' ] ) : "" ;
	$input_smilies = ( isset( $_POST[ 'input_smilies' ] ) ) ? $security -> checknum( $_POST[ 'input_smilies' ] ) : "" ;
	$input_blockcode = ( isset( $_POST[ 'input_blockcode' ] ) ) ? $security -> checknum( $_POST[ 'input_blockcode' ] ) : "" ;
	$input_allow_comments = ( isset( $_POST[ 'input_allow_comments' ] ) ) ? $security -> checknum( $_POST[ 'input_allow_comments' ] ) : "" ;
	$input_frontpage = ( isset( $_POST[ 'input_frontpage' ] ) ) ? $security -> checknum( $_POST[ 'input_frontpage' ] ) : "" ;
	$input_url_tag = ( isset( $_POST[ 'input_url_tag' ] ) ) ? $security -> checknum( $_POST[ 'input_url_tag' ] ) : "" ;
	$input_url_get = ( isset( $_POST[ 'input_url_get' ] ) ) ? $security -> checknum( $_POST[ 'input_url_get' ] ) : "" ;
	$input_status = ( isset( $_POST[ 'input_status' ] ) ) ? $security -> checknum( $_POST[ 'input_status' ] ) : "" ;
	$input_password = ( isset( $_POST[ 'input_password' ] ) ) ? $security -> checkvar( $_POST[ 'input_password' ] ) : "" ;
	$input_fields = ( isset( $_POST[ 'input_fields' ] ) ) ? $security -> checkvararray( $_POST[ 'input_fields' ] ) : "" ;
	$input_doteaserupload = ( isset( $_POST[ 'input_doteaserupload' ] ) ) ? $security -> checkvar( $_POST[ 'input_doteaserupload' ] ) : "" ;
	$input_dopreview = ( isset( $_POST[ 'input_dopreview' ] ) ) ? $security -> checkvar( $_POST[ 'input_dopreview' ] ) : "" ;
	$input_dospellcheck = ( isset( $_POST[ 'input_dospellcheck' ] ) ) ? $security -> checkvar( $_POST[ 'input_dospellcheck' ] ) : "" ;
	$input_appendarticlepage = ( isset( $_POST[ 'input_appendarticlepage' ] ) ) ? $security -> checkvar( $_POST[ 'input_appendarticlepage' ] ) : "" ;
	$input_zid = ( isset( $_POST[ 'input_zid' ] ) ) ? $security -> checknum( $_POST[ 'input_zid' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $system -> adminhashget() != $input_security_hash ) and( $preferences[ 'website_subsessions_admin' ] ) )
	{
		$html -> login( $words_articles[ 'ERROR' ], $words_articles[ 'INVALID_SESSION' ], "index.php" );
		exit;
	}
	
	$notice = "";
	
	if( $input_appendarticlepage )
	{
		$input_append_page = ( isset( $_POST[ 'input_append_page' ] ) ) ? $system -> stripthis( $_POST[ 'input_append_page' ] ) : "" ;
		
		if( $input_append_page )
		{
			$input_page = $input_append_page;
			$input_article_pagetitle = "";
			$input_article_pagetext = "";
		}
		else
		{
			$input_article_pagetitle = ( isset( $_POST[ 'input_article_pagetitle' ] ) ) ? $system -> stripthis( $_POST[ 'input_article_pagetitle' ] ) : "" ;
			$input_article_pagetext = ( isset( $_POST[ 'input_article_pagetext' ] ) ) ? $system -> stripthis( $_POST[ 'input_article_pagetext' ] ) : "" ;
			$input_page = ( isset( $_POST[ 'input_zid' ] ) ) ? $system -> stripthis( $_POST[ 'input_zid' ] ) : "" ;
		}
		
		$input_dofileedit = ( isset( $_POST[ 'input_dofileedit' ] ) ) ? $system -> stripthis( $_POST[ 'input_dofileedit' ] ) : "" ;
		$input_dopreview = ( isset( $_POST[ 'input_dopreview' ] ) ) ? $system -> stripthis( $_POST[ 'input_dopreview' ] ) : "" ;
		$query = $database -> dbquery( "SELECT a1.article_html, a1.article_smilies, a1.article_code, a2.articlepage_page, a2.articlepage_title FROM " . DB_PREFIX . "esselbach_ct_articles a1, " . DB_PREFIX . "esselbach_ct_articlespages a2 WHERE a2.articlepage_article = a1.article_id AND a2.articlepage_id = '" . $database -> dbescape( $input_page ) . "'" );
		list( $input_html, $input_smilies, $input_blockcode, $input_articlepage, $input_articlepagetitle ) = $database -> dbrow( $query );
		
		if( $input_articlepagetitle )
		{
			$input_articlepage .= " (" . htmlspecialchars( $input_articlepagetitle ) . ")";
		}
		
		$html -> makeheader( $words_articles[ 'APPEND_NEW_PAGE_AFTER_PAGE' ] . " " . $input_articlepage );
		
		if( $preferences[ 'articles_wysiwyg' ] )
		{
			$wysiwyg -> wysiwyginit( "input_article_pagetext" );
		}
		else
		{
			$html -> quickhtmlinit( "newform", "input_article_pagetext", "" );
		}
		
		$html -> filesinit( "articleattachmentsearch" );
		$html -> articleteaserpreviewinit();
		$html -> makesubheader();
		$html -> makegroupmenu( "articles" );
		
		if( $input_dofileedit )
		{
			$input_file = explode( "#", $input_dofileedit );
			$input_file = $security -> checknum( $input_file[ 1 ] );
		}
		else
		{
			$input_file = "";
		}
		
		if( $notice )
		{
			$html -> makeformheadera( $words_articles[ 'NOTICE' ], "newpage", "newform" );
			echo $notice;
			echo "<br /><br /><h2>" . $words_articles[ 'APPEND_NEW_PAGE_AFTER_PAGE' ] . " " . $input_articlepage . "</h2>";
		}
		elseif( $input_dopreview )
		{
			$input_article_parsed = $input_article_pagetext;
			
			if ( $input_blockcode )
			{
				if ( $input_url_tag )
				{
					$input_article_parsed = preg_replace( "#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1[url]\\2[/url]", $input_article_parsed );
				}
					
				if ( $input_url_get )
				{
					$input_article_parsed = $system -> geturltitles( $input_article_parsed );
				}
			}
			
			$input_article_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", $words_articles[ 'ATTACHMENT_HERE' ], $input_article_parsed );
			$input_article_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", $words_articles[ 'ATTACHMENT_IMG_HERE' ], $input_article_parsed );
			$input_article_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", $words_articles[ 'ATTACHMENT_THUMB_HERE' ], $input_article_parsed );
			
			if( !$input_html )
			{
				$input_article_parsed = $system -> dechomp( $input_article_parsed );
			}
			
			if( $input_smilies )
			{
				$input_article_parsed = $system -> smilies( $input_article_parsed );
			}
			
			if( $input_blockcode )
			{
				$input_article_parsed = $system -> code( $input_article_parsed );
			}
			
			$html -> makeformheadera( $words_articles[ 'PREVIEW' ], "newpage", "newform" );
			echo $system -> fixsmilies( $input_article_parsed );
			echo "<br /><br /><h2>" . $words_articles[ 'APPEND_NEW_PAGE_AFTER_PAGE' ] . " " . $input_articlepage . "</h2>";
		}
		else
		{
			$html -> makeformheadera( $words_articles[ 'APPEND_NEW_PAGE_AFTER_PAGE' ] . " " . $input_articlepage, "newpage", "newform" );
		}
		
		$html -> uppertext( $words_articles[ 'PAGE_TITLE' ], "input_article_pagetitle", $input_article_pagetitle );
		
		if( !$preferences[ 'articles_wysiwyg' ] )
		{
			$html -> quickhtml( "" );
		}
		
		$html -> upperform( $words_articles[ 'PAGE_TEXT' ], "input_article_pagetext", $input_article_pagetext, 25 );
		echo "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doaddappendarticlepage\" /><input type=\"hidden\" name=\"input_zid\" value=\"" . $input_page . "\" /><input type=\"submit\" name=\"input_dopreview\" value=\"" . $words_articles[ 'PREVIEW' ] . "\" />";
		
		if( function_exists( "pspell_new" ) )
		{
			echo "<input type=\"submit\" name=\"input_dospellcheck\" value=\"" . $words_articles[ 'SPELLING' ] . "\" />";
		}
		
		echo "<input type=\"submit\" name=\"input_doaddpage\" value=\"" . $words_articles[ 'ADD_PAGE' ] . "\" />";
		echo "<br /><br /><h2>" . $words_articles[ 'FILE_ATTACHMENTS' ] . "</h2>";
		$html -> tableheader( "","" );
		$query = $database -> dbquery( "SELECT articlefile_id, articlefile_filename, articlefile_title, articlefile_description, articlefile_mime FROM " . DB_PREFIX . "esselbach_ct_articlesfiles WHERE articlefile_author = '$login_username' AND articlefile_inuse = '0' ORDER BY articlefile_date DESC" );
		
		while( list( $articlefile_id, $articlefile_filename, $articlefile_title, $articlefile_description, $articlefile_mime ) = $database -> dbrow( $query ) )
		{
			if( ( $articlefile_mime == "image/jpeg" ) or( $articlefile_mime == "image/pjpeg" ) or( $articlefile_mime == "image/gif" ) or( $articlefile_mime == "image/png" ) )
			{
				if( function_exists( "imagecopyresized" ) )
				{
					$mid_link = "<a href=\"javascript:insert2('[thumb=" . $articlefile_id . "]')\"><img src=\"index.php?action=articleattachmentpreview&amp;input_fileid=" . $articlefile_id . "\" title=\"" . htmlspecialchars( $articlefile_description ) . "\" alt=\"" . htmlspecialchars( $articlefile_filename ) . "\" /></a><br />";
				}
				else
				{
					$mid_link = "<a href=\"javascript:insert2('[thumb=" . $articlefile_id . "]')\">" . htmlspecialchars( $articlefile_filename ) . "</a><br />";
				}
				
				$mid_link .= "[ <a href=\"javascript:insert2('[fullimage=" . $articlefile_id . "]')\">" . $words_articles[ 'ADD_AS_FULL_IMAGE' ] . "</a> | <a href=\"javascript:insert2('[thumb=" . $articlefile_id . "]')\">" . $words_articles[ 'ADD_AS_THUMBNAIL' ] . "</a> ]<br />";
			}
			else
			{
				$mid_link = "[ <a href=\"javascript:insert2('[attachment=$articlefile_id]Download" . $articlefile_filename . "[/attachment]')\">" . $words_articles[ 'ADD_DOWNLOAD' ] . "</a> ]<br />";
			}
			
			if( $input_file == $articlefile_id )
			{
				$mid_link .= "<textarea cols=\"80\" name=\"input_edittitle\" rows=\"1\" style=\"margin:0px;width:600px\">" . $articlefile_title . "</textarea><br />";
				$mid_link .= "<textarea cols=\"80\" name=\"input_editdescription\" rows=\"2\" style=\"margin:0px;width:600px\">" . $articlefile_description . "</textarea><br />";
				$mid_link .= "<input type=\"hidden\" name=\"input_editid\" value=\"" . $articlefile_id . "\" /><input type=\"submit\" name=\"input_doeditfile\" value=\"" . $words_articles[ 'GO' ] . "\" /><br />";
			}
			else
			{
				$mid_link .= "<strong>" . htmlspecialchars( $articlefile_title ) . "</strong><br />" . htmlspecialchars( $articlefile_description );
			}
			
			if( $input_file != $articlefile_id )
			{
				$html -> tableamiddle( $articlefile_filename, $mid_link, "input_dofileedit", $words_articles[ 'EDIT_FILE' ] . $articlefile_id, "input_dofileremove", $words_articles[ 'REMOVE_FILE' ] . $articlefile_id );
			}
			else
			{
				$html -> tableamiddle( $articlefile_filename, $mid_link, "input_dofileedit", 0, 0, 0, 0 );
			}
		}
		
		$html -> maketablefooter();
		echo "<a href=\"javascript:files_win()\">" . $words_articles[ 'SEARCH_FILE_ATTACHMENTS' ] . "</a><br /><br />";
		echo "<strong>" . $words_articles[ 'FILE' ] . ":</strong><br /><input type=\"file\" name=\"input_file\" /><br />";
		$html -> upperform( $words_articles[ 'TITLE' ], "input_file_title", "", 1 );
		$html -> upperform( $words_articles[ 'DESCRIPTION' ], "input_file_description", "", 2 );
		echo "<input type=\"submit\" name=\"input_doupload\" value=\"" . $words_articles[ 'UPLOAD' ] . "\" />";
		$html -> makeformfooter();
	}
	else
	{
		if( !$input_website )
		{
			$input_website = 0;
		}
		
		if( $input_doteaserupload )
		{
			$file_name = ( isset( $_FILES[ 'input_teaserfile' ][ 'name' ] ) ) ? $security -> checkvar( strtolower( $_FILES[ 'input_teaserfile' ][ 'name' ] ) ) : "" ;
			$tmp_name = ( isset( $_FILES[ 'input_teaserfile' ][ 'tmp_name' ] ) ) ? $_FILES[ 'input_teaserfile' ][ 'tmp_name' ] : "" ;
			$file_size = ( isset( $_FILES[ 'input_teaserfile' ][ 'size' ] ) ) ? $security -> checknum( $_FILES[ 'input_teaserfile' ][ 'size' ] ) : "" ;
			$file_type = ( isset( $_FILES[ 'input_teaserfile' ][ 'type' ] ) ) ? $security -> checkvar( $_FILES[ 'input_teaserfile' ][ 'type' ] ) : "" ;
			$query = $database -> dbquery( "SELECT filetype_adminsize, filetype_extension FROM " . DB_PREFIX . "esselbach_ct_filetypes WHERE filetype_mime = '" . $file_type . "' AND filetype_isimage = '1'" );
			
			if( $database -> dbrows( $query ) )
			{
				list( $file_allowedsize, $file_extension ) = $database -> dbrow( $query );
				
				if( $file_size > $file_allowedsize )
				{
					$notice = $words_articles[ 'FILE_TOO_LARGE' ] . " " . $file_allowedsize . " " . $words_articles[ 'BYTES' ];
				}
				
				if( !preg_match( "/" . $file_extension . "/i", $file_name ) )
				{
					$notice = $words_articles[ 'FILETYPE_INVALID' ];
				}
			}
			else
			{
				$notice = $words_articles[ 'FILETYPE_NOT_ALLOWED_IMAGE' ];
			}
			
			if( !$tmp_name )
			{
				$notice = $words_articles[ 'FILE_EMPTY' ];
			}
			
			$file = @fopen( $tmp_name, "r" );
			
			if( $file )
			{
				$binary = fread( $file, filesize( $tmp_name ) );
				
				if( ( $file_type == "image/png" or $file_type == "image/pjpeg" or $file_type == "image/jpeg" or $file_type == "image/gif" ) and function_exists( "imagecreatefromstring" ) )
				{
					if( $preferences[ 'articles_image_teaserwidth' ] )
					{
						$teaserwidth = $preferences[ 'articles_image_teaserwidth' ];
					}
					else
					{
						$teaserwidth = 20;
					}
					
					$teaser_image = $system -> resizeimage( $binary, $file_type, $teaserwidth, "", "" );
					$teaser_size = strlen( $teaser_image );
					$teaser_image = $database -> dbescape( $teaser_image );
				}
				else
				{
					$teaser_size = $file_size;
					$teaser_image = $database -> dbescape( $binary );
				}
				
				fclose( $file );
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_articlesteaserimages (newsteaserimage_id, newsteaserimage_author, newsteaserimage_filename, newsteaserimage_mime, newsteaserimage_size, newsteaserimage_binary, newsteaserimage_default, newsteaserimage_article, newsteaserimage_ip) VALUES (NULL, '" . $login_username . "', '" . $file_name . "', '" . $file_type . "', '" . $teaser_size . "', '" . $teaser_image . "', '0', '" . $input_zid . "', '" . $ipaddr . "')" );
				$notice = $words_articles[ 'TEASER_IMAGE_ADDED' ];
			}
		}
		
		if( !$notice )
		{
			if( !$input_article_title )
			{
				$notice = $words_articles[ 'ARTICLE_NO_TITLE' ];
			}
			
			if( !$input_article_summary )
			{
				$notice = $words_articles[ 'ARTICLE_NO_SUMMARY' ];
			}
			
			if( $preferences[ 'articles_start_expire_date' ] )
			{
				if( !checkdate( $input_month, $input_day, $input_year ) or !checkdate( $input_expire_month, $input_expire_day, $input_expire_year ) )
				{
					$notice = $words_articles[ 'INVALID_DATE' ];
				}
			}
			
			if( ( $input_status == 3 ) and( !$input_password ) )
			{
				$notice = $words_articles[ 'NO_PASSWORD' ];
			}
		}
		
		if( !$input_article_description )
		{
			$input_article_description = $system -> description( $input_article_summary );
		}
		
		if( !$input_article_keywords )
		{
			$input_article_keywords = $system -> keywords( $input_article_summary );
		}
		
		if( $input_dospellcheck )
		{
			if( $dictionary = @pspell_new( $preferences[ 'website_spellchecker' ] ) )
			{
				$words_array = explode( " ", $input_article_summary );
				$input_page_spelling = "";
				$input_spell_errors = 0;
				
				foreach( $words_array as $word )
				{
					if( pspell_check( $dictionary, $word ) )
					{
						$input_page_spelling .= $word . " ";
					}
					else
					{
						$suggestions = implode( ", ", pspell_suggest( $dictionary, $word ) );
						( $suggestions ) ? $suggestions = $words_articles[ 'SUGGESTIONS' ] . ": " . $suggestions : $suggestions = $words_articles[ 'NO_SUGGESTIONS' ];
						$input_page_spelling .= "<span style=\"background-color: rgb(235, 15, 20); font-weight:bold;\" title=\"" . $suggestions . "\"><strong>" . $word . "</strong></span> ";
						$input_spell_errors++;
					}
				}
				
				$notice = $words_articles[ 'THE_SPELL_CHECKER_FOUND' ] . " " . $input_spell_errors . " " . $words_articles[ 'ERRORS' ] . ":<br /><br />" . $input_page_spelling;
			}
		}
		
		if( ( $notice ) or( $input_dopreview ) )
		{
			AdminEditArticle( $input_zid, $notice );
		}
		else
		{
			if( is_array( $input_fields ) )
			{
				$input_fields_encoded = base64_encode( $system -> stripthis( $input_fields[ 0 ] ) );
				
				for( $i = 1; $i < 24; $i++ )
				{
					$input_fields_encoded .= "|";
					
					if( isset( $input_fields[ $i ] ) )
					{
						$input_fields_encoded .= base64_encode( $system -> stripthis( $input_fields[ $i ] ) );
					}
				}
			}
			else
			{
				$input_fields_encoded = "";
			}
			
			$input_fields = "";
			
			if ( $input_blockcode )
			{
				if ( $input_url_tag )
				{
					$input_article_summary = preg_replace( "#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1[url]\\2[/url]", $input_article_summary );
				}
					
				if ( $input_url_get )
				{
					$input_article_summary = $system -> geturltitles( $input_article_summary );
				}
			}
			
			$input_article_summary_parsed = stripslashes( $input_article_summary );
			
			if( !$input_html )
			{
				$input_article_summary_parsed = $system -> dechomp( $input_article_summary_parsed );
			}
			
			if( $input_smilies )
			{
				$input_article_summary_parsed = $system -> smilies( $input_article_summary_parsed );
			}
			
			if( $input_blockcode )
			{
				$input_article_summary_parsed = $system -> code( $input_article_summary_parsed );
			}
			
			$input_article_summary_parsed = $database -> dbescape( $input_article_summary_parsed );
			
			if( $preferences[ 'articles_start_expire_date' ] )
			{
				if( $input_now )
				{
					$input_startdate = date( "Y-m-d H:i:s", mktime() );
				}
				else
				{
					$input_startdate = date( "Y-m-d H:i:s", mktime( $input_hour, $input_minute, $input_second, $input_month, $input_day, $input_year ) );
				}
				
				$input_expiredate = date( "Y-m-d H:i:s", mktime( $input_expire_hour, $input_expire_minute, $input_expire_second, $input_expire_month, $input_expire_day, $input_expire_year ) );
			}
			
			if( $input_article_tags )
			{
				$query = $database -> dbquery( "SELECT article_tags FROM " . DB_PREFIX . "esselbach_ct_articles WHERE article_id = '" . $input_zid . "'" );
				list( $article_tags_old ) = $database -> dbrow( $query );
				$article_tags_new = stripslashes( $input_article_tags );
				
				if( $article_tags_old != $article_tags_new )
				{
					$article_tags_old_array = explode( ",", $article_tags_old );
					
					foreach( $article_tags_old_array as $old_tag )
					{
						$query = $database -> dbquery( "SELECT articletag_id FROM " . DB_PREFIX . "esselbach_ct_articlestags WHERE articletag_tag = '" . $database -> dbescape( $old_tag ) . "' AND articletag_website = '" . $input_website . "'" );
						
						if( $database -> dbrows( $query ) < 2 )
						{
							$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_articlestags WHERE articletag_tag = '" . $database -> dbescape( $old_tag ) . "' AND articletag_website = '" . $input_website . "'" );
						}
						else
						{
							$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articlestags SET articletag_count = articletag_count - 1, articletag_date = now() WHERE articletag_tag = '" . $database -> dbescape( $old_tag ) . "' AND articletag_website = '" . $input_website . "'" );
						}
					}
					
					$article_tags_new_array = explode( ",", $article_tags_new );
					
					foreach( $article_tags_new_array as $new_tag )
					{
						$query = $database -> dbquery( "SELECT articletag_id FROM " . DB_PREFIX . "esselbach_ct_articlestags WHERE articletag_tag = '" . $database -> dbescape( $new_tag ) . "' AND articletag_website = '" . $input_website . "'" );
						
						if( $database -> dbrows( $query ) )
						{
							$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articlestags SET articletag_count = articletag_count + 1, articletag_date = now() WHERE articletag_tag = '" . $database -> dbescape( $new_tag ) . "' AND articletag_website = '" . $input_website . "'" );
						}
						else
						{
							$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_articlestags (articletag_id, articletag_website, articletag_tag, articletag_seo, articletag_count, articletag_date) VALUES (NULL, '" . $input_website . "', '" . $database -> dbescape( $new_tag ) . "', '" . $system -> doseo( $database -> dbescape( $new_tag ) ) . "', '1', now())" );
						}
					}
				}
			}
			
			if( !$input_article_seo )
			{
				$input_article_seo = $input_article_title;
			}
			
			$input_article_seo = $system -> doseo( $input_article_seo );
			$query = $database -> dbquery( "SELECT COUNT(article_id) FROM " . DB_PREFIX . "esselbach_ct_articles WHERE article_seo = '" . $input_article_seo . "'" );
			list( $seo_articles ) = $database -> dbrow( $query );
			
			if( $seo_articles > 1 )
			{
				$input_article_seo .= "_" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
			}
			
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articles SET article_website = '" . $input_website . "', article_category = '" . $input_category . "', article_author = '" . $login_username . "', article_title = '" . $input_article_title . "', article_seo = '" . $input_article_seo . "', article_rawsummary = '" . $input_article_summary . "', article_summary = '" . $input_article_summary_parsed . "', article_description = '" . $input_article_description . "', article_keywords = '" . $input_article_keywords . "', article_tags = '" . $input_article_tags . "', article_teaser = '" . $input_teaserimage . "', article_allowcomments = '" . $input_allow_comments . "', article_frontpage = '" . $input_frontpage . "', article_fields = '" . $input_fields_encoded . "', article_sticky = '" . $input_top . "', article_html = '" . $input_html . "', article_smilies = '" . $input_smilies . "', article_code = '" . $input_blockcode . "', article_status = '" . $input_status . "', article_password = '" . $input_password . "', article_date = now(), article_editip = '" . $ipaddr . "', article_editadmin = '" . $login_username . "' WHERE article_id = '" . $input_zid . "'" );
			
			if( $preferences[ 'articles_start_expire_date' ] )
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articles SET article_startdate = '" . $input_startdate . "', article_expiredate = '" . $input_expiredate . "', article_neverexpire = '" . $input_expire_never . "' WHERE article_id = '" . $input_zid . "'" );
			}
			
			$html -> login( $words_articles[ 'EDIT_ARTICLE' ], $words_articles[ 'ARTICLE_CHANGED' ], "index.php?action=managearticles" );
		}
	}
}
?>