<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 2                                                  |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Content
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminDoAddPage
 * A function to add a new page to the database
 * @author Philipp Louis Esselbach
 */
function AdminDoAddPage()
{
	global $database, $security, $system, $html, $ipaddr, $login_username, $preferences, $words_content;
	$input_website = ( isset( $_POST[ 'input_website' ] ) ) ? $security -> checknum( $_POST[ 'input_website' ] ) : "" ;
	$input_category = ( isset( $_POST[ 'input_category' ] ) ) ? $security -> checknum( $_POST[ 'input_category' ] ) : "" ;
	$input_frontpage = ( isset( $_POST[ 'input_frontpage' ] ) ) ? $security -> checknum( $_POST[ 'input_frontpage' ] ) : 0 ;
	$input_page_title = ( isset( $_POST[ 'input_page_title' ] ) ) ? $security -> checkvar( $_POST[ 'input_page_title' ] ) : "" ;
	$input_page_seo = ( isset( $_POST[ 'input_page_title' ] ) ) ? $security -> checkvar( $_POST[ 'input_page_seo' ] ) : "" ;
	$input_page_description = ( isset( $_POST[ 'input_page_description' ] ) ) ? $security -> checkvar( $_POST[ 'input_page_description' ] ) : "" ;
	$input_page_keywords = ( isset( $_POST[ 'input_page_keywords' ] ) ) ? $security -> checkvar( $_POST[ 'input_page_keywords' ] ) : "" ;
	$input_page_content = ( isset( $_POST[ 'input_page_content' ] ) ) ? $security -> checkvar( $_POST[ 'input_page_content' ] ) : "" ;
	$input_page_tags = ( isset( $_POST[ 'input_page_tags' ] ) ) ? $security -> checkvar( $_POST[ 'input_page_tags' ] ) : "" ;
	$input_html = ( isset( $_POST[ 'input_html' ] ) ) ? $security -> checknum( $_POST[ 'input_html' ] ) : "" ;
	$input_smilies = ( isset( $_POST[ 'input_smilies' ] ) ) ? $security -> checknum( $_POST[ 'input_smilies' ] ) : "" ;
	$input_blockcode = ( isset( $_POST[ 'input_blockcode' ] ) ) ? $security -> checknum( $_POST[ 'input_blockcode' ] ) : "" ;
	$input_url_tag = ( isset( $_POST[ 'input_url_tag' ] ) ) ? $security -> checknum( $_POST[ 'input_url_tag' ] ) : "" ;
	$input_url_get = ( isset( $_POST[ 'input_url_get' ] ) ) ? $security -> checknum( $_POST[ 'input_url_get' ] ) : "" ;
	$input_status = ( isset( $_POST[ 'input_status' ] ) ) ? $security -> checknum( $_POST[ 'input_status' ] ) : "" ;
	$input_password = ( isset( $_POST[ 'input_password' ] ) ) ? $security -> checkvar( $_POST[ 'input_password' ] ) : "" ;
	$input_form_mail = ( isset( $_POST[ 'input_form_mail' ] ) ) ? $security -> checkvar( $_POST[ 'input_form_mail' ] ) : "" ;
	$input_form_name = ( isset( $_POST[ 'input_form_name' ] ) ) ? $security -> checkvararray( $_POST[ 'input_form_name' ] ) : "" ;
	$input_form_status = ( isset( $_POST[ 'input_form_status' ] ) ) ? $security -> checknumarray( $_POST[ 'input_form_status' ] ) : "" ;
	$input_doupload = ( isset( $_POST[ 'input_doupload' ] ) ) ? $security -> checkvar( $_POST[ 'input_doupload' ] ) : "" ;
	$input_file_title = ( isset( $_POST[ 'input_file_title' ] ) ) ? $security -> checkvararray( $_POST[ 'input_file_title' ] ) : array() ;
	$input_file_description = ( isset( $_POST[ 'input_file_description' ] ) ) ? $security -> checkvararray( $_POST[ 'input_file_description' ] ) : array() ;
	$input_dofileremove = ( isset( $_POST[ 'input_dofileremove' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileremove' ] ) : "" ;
	$input_dofileedit = ( isset( $_POST[ 'input_dofileedit' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileedit' ] ) : "" ;
	$input_doeditfile = ( isset( $_POST[ 'input_doeditfile' ] ) ) ? $security -> checkvar( $_POST[ 'input_doeditfile' ] ) : "" ;
	$input_edittitle = ( isset( $_POST[ 'input_edittitle' ] ) ) ? $security -> checkvar( $_POST[ 'input_edittitle' ] ) : "" ;
	$input_editdescription = ( isset( $_POST[ 'input_editdescription' ] ) ) ? $security -> checkvar( $_POST[ 'input_editdescription' ] ) : "" ;
	$input_editid = ( isset( $_POST[ 'input_editid' ] ) ) ? $security -> checknum( $_POST[ 'input_editid' ] ) : "" ;
	$input_dopreview = ( isset( $_POST[ 'input_dopreview' ] ) ) ? $security -> checkvar( $_POST[ 'input_dopreview' ] ) : "" ;
	$input_dospellcheck = ( isset( $_POST[ 'input_dospellcheck' ] ) ) ? $security -> checkvar( $_POST[ 'input_dospellcheck' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $system -> adminhashget() != $input_security_hash ) and( $preferences[ 'website_subsessions_admin' ] ) )
	{
		$html -> login( $words_content[ 'ERROR' ], $words_content[ 'INVALID_SESSION' ], "index.php" );
		exit;
	}
	
	$notice = "";
	
	if( $input_doupload )
	{
		$error = "";
		
		for( $a = 0; $a < count( $_FILES[ 'input_file' ][ 'name' ] ); $a++ )
		{
			$file_name = ( isset( $_FILES[ 'input_file' ][ 'name' ][ $a ] ) ) ? $security -> checkvar( strtolower( $_FILES[ 'input_file' ][ 'name' ][ $a ] ) ) : "" ;
			$tmp_name = ( isset( $_FILES[ 'input_file' ][ 'tmp_name' ][ $a ] ) ) ? $_FILES[ 'input_file' ][ 'tmp_name' ][ $a ] : "" ;
			$file_size = ( isset( $_FILES[ 'input_file' ][ 'size' ][ $a ] ) ) ? $security -> checknum( $_FILES[ 'input_file' ][ 'size' ][ $a ] ) : "" ;
			$file_type = ( isset( $_FILES[ 'input_file' ][ 'type' ][ $a ] ) ) ? $security -> checkvar( $_FILES[ 'input_file' ][ 'type' ][ $a ] ) : "" ;
			
			if( $file_name )
			{
				$query = $database -> dbquery( "SELECT filetype_adminsize, filetype_extension FROM " . DB_PREFIX . "esselbach_ct_filetypes WHERE filetype_mime = '" . $database -> dbescape( $file_type ) . "'" );
				
				if( $database -> dbrows( $query ) )
				{
					list( $file_allowedsize, $file_extension ) = $database -> dbrow( $query );
					
					if( $file_size > $file_allowedsize )
					{
						$error = $words_content[ 'FILE_TOO_LARGE' ] . " " . $file_allowedsize . " " . $words_content[ 'BYTES' ];
					}
					
					if( !preg_match( "/" . $file_extension . "/i", $file_name ) )
					{
						$error = $words_content[ 'FILETYPE_INVALID' ];
					}
				}
				else
				{
					$error = $words_content[ 'FILETYPE_UNKNOWN' ];
				}
				
				if( !$tmp_name )
				{
					$error = $words_content[ 'FILE_EMPTY' ];
				}
				
				if( !$error )
				{
					$file = @fopen( $tmp_name, "r" );
					
					if( $file )
					{
						$binary = fread( $file, filesize( $tmp_name ) );
						
						if( ( $file_type == "image/png" or $file_type == "image/pjpeg" or $file_type == "image/jpeg" or $file_type == "image/gif" ) and function_exists( "imagecreatefromstring" ) )
						{
							if( $preferences[ 'content_image_width' ] )
							{
								$binary = $system -> resizeimage( $binary, $file_type, $preferences[ 'content_image_width' ], $preferences[ 'content_image_brandtext' ], $preferences[ 'content_image_brandcolor' ] );
								$file_size = strlen( $binary );
							}
							
							$thumb_image = $system -> resizeimage( $binary, $file_type, $preferences[ 'content_image_thumbwidth' ], "", "" );
							$thumb_size = strlen( $thumb_image );
							$thumb_image = $database -> dbescape( $thumb_image );
						}
						else
						{
							$thumb_image = "";
							$thumb_size = 0;
						}
						
						$binary = $database -> dbescape( $binary );
						fclose( $file );
						
						if( !$input_file_title[ $a ] )
						{
							$input_file_title[ $a ] = $file_name;
						}
						
						if( !$input_file_description[ $a ] )
						{
							$input_file_description[ $a ] = $words_content[ 'NO_DESCRIPTION' ];
						}
						
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_contentfiles (contentfile_id, contentfile_author, contentfile_filename, contentfile_title, contentfile_description, contentfile_mime, contentfile_size, contentfile_binary, contentfile_thumbsize, contentfile_thumbimage, contentfile_inuse, contentfile_page, contentfile_date, contentfile_views, contentfile_activity, contentfile_postip, contentfile_editip) VALUES (NULL, '" . $login_username . "', '" . $file_name . "', '" . $input_file_title[ $a ] . "', '" . $input_file_description[ $a ] . "', '" . $file_type . "', '" . $file_size . "', '" . $binary . "', '" . $thumb_size . "', '" . $thumb_image . "', '0', '0', now(), '0', now(), '" . $ipaddr . "', '" . $ipaddr . "')" );
						$notice = $words_content[ 'UPLOAD_SUCCESSFULLY' ];
						$input_file_title[ $a ] = "";
						$input_file_description[ $a ] = "";
					}
				}
				else
				{
					$file_id = $a + 1;
					$notice = $words_content[ 'FILE' ] . " #" . $file_id . ":<br />" . $error;
				}
			}
		}
	}
	
	if( $input_dofileremove )
	{
		$input_file = explode( "#", $input_dofileremove );
		$input_file = $security -> checknum( $input_file[ 1 ] );
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_contentfiles WHERE contentfile_author = '" . $login_username . "' AND contentfile_id = '" . $input_file . "'" );
		$notice = $words_content[ 'FILE_REMOVED' ];
	}
	
	if( $input_category )
	{
		$query = $database -> dbquery( "SELECT contentcat_website FROM " . DB_PREFIX . "esselbach_ct_contentcats WHERE contentcat_id = '" . $input_category . "'" );
		list( $contentcat_website ) = $database -> dbrows( $query );
		
		if( $contentcat_website and $contentcat_website != $input_website )
		{
			$notice = $words_content[ 'WEBSITE_CATEGORY' ];
		}
	}
	
	if( !$notice )
	{
		if( !$input_page_title )
		{
			$notice = $words_content[ 'PAGE_NO_TITLE' ];
		}
		
		if( !$input_page_content )
		{
			$notice = $words_content[ 'PAGE_NO_CONTENT' ];
		}
		
		if( ( $input_status == 3 ) and( !$input_password ) )
		{
			$notice = $words_content[ 'NO_PASSWORD' ];
		}
		
		if( $input_form_mail )
		{
			if( !preg_match( "/^[A-Z0-9._%-]+@[A-Z0-9[:alpha:]._%-]+\.[A-Z]{2,6}$/i", $input_form_mail ) )
			{
				$notice = $words_content[ 'INVALID_EMAIL' ];
			}
		}
	}
	
	if( $input_dofileedit )
	{
		$notice = "";
	}
	
	if( $input_doeditfile )
	{
		if( !$input_edittitle )
		{
			$query = dbquery( "SELECT contentfile_filename FROM " . DB_PREFIX . "esselbach_ct_contentfiles WHERE contentfile_id = '" . $input_editid . "'" );
			list( $input_edittitle ) = $database -> dbquery( $query );
			$input_edittitle = $database -> dbescape( $input_edittitle );
		}
		
		if( !$input_editdescription )
		{
			$input_editdescription = $words_content[ 'NO_DESCRIPTION' ];
		}
		
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_contentfiles SET contentfile_title = '" . $input_edittitle . "', contentfile_description = '" . $input_editdescription . "', contentfile_editip = '" . $ipaddr . "' WHERE contentfile_author = '" . $login_username . "' AND contentfile_id = '" . $input_editid . "'" );
		$notice = $words_content[ 'DESCRIPTION_CHANGED' ];
	}
	
	if( !$input_page_description )
	{
		$input_page_description = $system -> description( $input_page_content );
	}
	
	if( !$input_page_keywords )
	{
		$input_page_keywords = $system -> keywords( $input_page_content );
	}
	
	if( $input_dospellcheck )
	{
		if( $dictionary = @pspell_new( $preferences[ 'website_spellchecker' ] ) )
		{
			$words_array = explode( " ", $input_page_content );
			$input_page_spelling = "";
			$input_spell_errors = 0;
			
			foreach( $words_array as $word )
			{
				if( pspell_check( $dictionary, $word ) )
				{
					$input_page_spelling .= $word . " ";
				}
				else
				{
					$suggestions = implode( ", ", pspell_suggest( $dictionary, $word ) );
					( $suggestions ) ? $suggestions = $words_content[ 'SUGGESTIONS' ] . ": " . $suggestions : $suggestions = $words_content[ 'NO_SUGGESTIONS' ];
					$input_page_spelling .= "<span style=\"background-color: rgb(235, 15, 20); font-weight:bold;\" title=\"" . $suggestions . "\"><strong>" . $word . "</strong></span> ";
					$input_spell_errors++;
				}
			}
			
			$notice = $words_content[ 'THE_SPELL_CHECKER_FOUND' ] . " " . $input_spell_errors . " " . $words_content[ 'ERRORS' ] . ":<br /><br />" . $input_page_spelling;
		}
	}
	
	if( ( $notice ) or( $input_dopreview ) or( $input_dofileedit ) )
	{
		AdminAddPage( $notice );
	}
	else
	{
		$seo_url = ( $preferences[ 'website_mod_rewrite' ] ) ? "" : "contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] ;
		if( !$input_category )
		{
			$input_category = 0;
		}
		
		if( ( $input_form_mail ) or( $input_form_name[ 0 ] ) )
		{
			$input_encoded_form = "";
			
			for( $i = 0; $i < 24; $i++ )
			{
				$input_encoded_form .= $input_form_status[ $i ] . "|^Z|" . base64_encode( $input_form_name[ $i ] ) . "|^X|";
			}
			
			$input_encoded_form .= $input_form_mail;
		}
		else
		{
			$input_encoded_form = "";
		}
		
		if ( $input_blockcode )
		{
			if ( $input_url_tag )
			{
				$input_page_content = preg_replace( "#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1[url]\\2[/url]", $input_page_content );
			}
				
			if ( $input_url_get )
			{
				$input_page_content = $system -> geturltitles( $input_page_content );
			}
		}
		
		$input_page_parsed = stripslashes( $input_page_content );
		
		if( !$input_html )
		{
			$input_page_parsed = $system -> dechomp( $input_page_parsed );
		}
		
		if( $input_smilies )
		{
			$input_page_parsed = $system -> smilies( $input_page_parsed );
		}
		
		if( $input_blockcode )
		{
			$input_page_parsed = $system -> code( $input_page_parsed );
			$input_page_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=content&amp;action=attachments&amp;id=\\1\">\\2</a>", $input_page_parsed );
			$input_page_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=content&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_page_parsed );
			$input_page_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"" . $seo_url . "content" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\" title=\"" . $words_content[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"contentteller.php?ct=content&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_page_parsed );
		}
		
		$input_page_parsed = $database -> dbescape( $input_page_parsed );
		$input_page_title = htmlspecialchars( $input_page_title );
		
		if( !$input_page_seo )
		{
			$input_page_seo = $input_page_title;
		}
		
		$input_page_seo = $system -> doseo( $input_page_seo );
		$query = $database -> dbquery( "SELECT COUNT(content_id) FROM " . DB_PREFIX . "esselbach_ct_content WHERE content_seo = '" . $input_page_seo . "'" );
		list( $seo_pages ) = $database -> dbrow( $query );
		
		if( $seo_pages )
		{
			$input_page_seo .= "_" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
		}
		
		if( !$input_page_tags and $preferences[ 'content_automated_tags' ] )
		{
			$input_page_tags = $system -> tags( $input_page_title );
		}
		
		$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_content (content_id, content_author, content_website, content_category, content_title, content_seo, content_rawtext, content_text, content_description, content_keywords, content_tags, content_form, content_html, content_smilies, content_code, content_status, content_password, content_position, content_date, content_frontpage, content_views, content_activity, content_postip, content_editip) VALUES (NULL, '" . $login_username . "', '" . $input_website . "', '" . $input_category . "', '" . $input_page_title . "', '" . $input_page_seo . "', '" . $input_page_content . "', '" . $input_page_parsed . "', '" . $input_page_description . "', '" . $input_page_keywords . "', '" . $input_page_tags . "', '" . $input_encoded_form . "', '" . $input_html . "', '" . $input_smilies . "', '" . $input_blockcode . "', '" . $input_status . "', '" . $input_password . "', '1', now(), '" . $input_frontpage . "', '0', now(), '" . $ipaddr . "', '" . $ipaddr . "')" );
		$input_page = $database -> dblastinsert();
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_contentfiles SET contentfile_inuse = '1', contentfile_page = '" . $input_page . "', contentfile_activity = now(), contentfile_editip = '" . $ipaddr . "' WHERE contentfile_author = '" . $login_username . "' AND contentfile_inuse = '0'" );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_content SET content_position = '" . $input_page . "' WHERE content_id = '" . $input_page . "'" );
		
		if( $input_page_tags )
		{
			$tags = explode( ",", $input_page_tags );
			
			foreach( $tags as $tag )
			{
				$tag_seo = $system -> doseo( $tag );
				$query = $database -> dbquery( "SELECT contenttag_id FROM " . DB_PREFIX . "esselbach_ct_contenttags WHERE contenttag_seo = '" . $tag_seo . "' AND (contenttag_website = '0' AND contenttag_website = '" . $input_website . "')" );
				
				if( $database -> dbrows( $query ) )
				{
					$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_contenttags SET contenttag_count = contenttag_count + 1, contenttag_date = now() WHERE contenttag_tag = '" . $tag . "' AND (contenttag_website = '0' AND contenttag_website = '" . $input_website . "')" );
				}
				else
				{
					$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_contenttags (contenttag_id, contenttag_website, contenttag_tag, contenttag_seo, contenttag_count, contenttag_date) VALUES (NULL, '" . $input_website . "', '" . $tag . "', '" . $tag_seo . "', '1', now())" );
				}
			}
		}
		
		$html -> login( $words_content[ 'ADD_NEW_PAGE' ], $words_content[ 'PAGE_ADDED' ], "index.php?action=managepages" );
	}
}
?>