<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 2                                                  |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Files
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminDoAddFilesTeaserImage
 * A function to add a teaser image to the database
 * @author Philipp Louis Esselbach
 */
function AdminDoAddFilesTeaserImage()
{
	global $database, $security, $system, $html, $ipaddr, $login_username, $preferences, $words_files;
	$input_doupload = ( isset( $_POST[ 'input_doupload' ] ) ) ? $security -> checkvar( $_POST[ 'input_doupload' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;
	
	if( ( $system -> adminhashget() != $input_security_hash ) and( $preferences[ 'website_subsessions_admin' ] ) )
	{
		$html -> login( $words_files[ 'ERROR' ], $words_files[ 'INVALID_SESSION' ], "index.php" );
		exit;
	}
	
	if( $input_doupload )
	{
		$file_name = ( isset( $_FILES[ 'input_file' ][ 'name' ] ) ) ? $security -> checkvar( strtolower( $_FILES[ 'input_file' ][ 'name' ] ) ) : "" ;
		$tmp_name = ( isset( $_FILES[ 'input_file' ][ 'tmp_name' ] ) ) ? $_FILES[ 'input_file' ][ 'tmp_name' ] : "" ;
		$file_size = ( isset( $_FILES[ 'input_file' ][ 'size' ] ) ) ? $security -> checknum( $_FILES[ 'input_file' ][ 'size' ] ) : "" ;
		$file_type = ( isset( $_FILES[ 'input_file' ][ 'type' ] ) ) ? $security -> checkvar( $_FILES[ 'input_file' ][ 'type' ] ) : "" ;
		$query = $database -> dbquery( "SELECT filetype_adminsize, filetype_extension FROM " . DB_PREFIX . "esselbach_ct_filetypes WHERE filetype_mime = '" . $file_type . "' AND filetype_isimage = '1'" );
		
		if( $database -> dbrows( $query ) )
		{
			list( $file_allowedsize, $file_extension ) = $database -> dbrow( $query );
			
			if( $file_size > $file_allowedsize )
			{
				$html -> login( $words_files[ 'ERROR' ], $words_files[ 'FILE_TOO_LARGE' ] . " " . $file_allowedsize . " " . $words_files[ 'BYTES' ], "index.php?action=managefilesteaserimages" );
			}
			
			if( !preg_match( "/" . $file_extension . "/i", $file_name ) )
			{
				$html -> login( $words_files[ 'ERROR' ], $words_files[ 'FILETYPE_INVALID' ], "index.php?action=managefilesteaserimages" );
			}
		}
		else
		{
			$html -> login( $words_files[ 'ERROR' ], $words_files[ 'FILETYPE_NOT_ALLOWED_IMAGE' ], "index.php?action=managefilesteaserimages" );
		}
		
		if( !$tmp_name )
		{
			$html -> login( $words_files[ 'ERROR' ], $words_files[ 'FILE_EMPTY' ], "index.php?action=managefileteaserimages" );
		}
		
		$file = @fopen( $tmp_name, "r" );
		
		if( $file )
		{
			$binary = fread( $file, filesize( $tmp_name ) );
			
			if( ( $file_type == "image/png" or $file_type == "image/pjpeg" or $file_type == "image/jpeg" or $file_type == "image/gif" ) and function_exists( "imagecreatefromstring" ) )
			{
				$teaser_image = $system -> resizeimage( $binary, $file_type, $preferences[ 'files_image_teaserwidth' ], "", "" );
				$teaser_size = strlen( $teaser_image );
				$teaser_image = $database -> dbescape( $teaser_image );
			}
			else
			{
				$teaser_size = $file_size;
				$teaser_image = $database -> dbescape( $binary );
			}
			
			fclose( $file );
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesteaserimages (fileteaserimage_id, fileteaserimage_author, fileteaserimage_filename, fileteaserimage_mime, fileteaserimage_size, fileteaserimage_binary, fileteaserimage_default, fileteaserimage_file, fileteaserimage_ip) VALUES (NULL, '" . $login_username . "', '" . $file_name . "', '" . $file_type . "', '" . $teaser_size . "', '" . $teaser_image . "', '1', '0', '" . $ipaddr . "')" );
			$html -> login( $words_files[ 'ADD_TEASER_IMAGE' ], $words_files[ 'TEASER_IMAGE_ADDED' ], "index.php?action=managefilesteaserimages" );
		}
	}
}
?>