<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 2                                                  |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Knowledgebase
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminDoAddNewKnowledgebaseEntry
 * A function to add a new knowledgebase entry 
 * @author Philipp Louis Esselbach
 */
function AdminDoAddNewKnowledgebaseEntry()
{
	global $database, $security, $system, $html, $ipaddr, $login_username, $preferences, $uwrapper, $words_knowledgebase;
	$input_website = ( isset( $_POST[ 'input_website' ] ) ) ? $security -> checknum( $_POST[ 'input_website' ] ) : "" ;
	$input_category = ( isset( $_POST[ 'input_category' ] ) ) ? $security -> checknum( $_POST[ 'input_category' ] ) : "" ;
	$input_knowledgebase_question = ( isset( $_POST[ 'input_knowledgebase_question' ] ) ) ? $security -> checkvar( $_POST[ 'input_knowledgebase_question' ] ) : "" ;
	$input_knowledgebase_seo = ( isset( $_POST[ 'input_knowledgebase_seo' ] ) ) ? $security -> checkvar( $_POST[ 'input_knowledgebase_seo' ] ) : "" ;
	$input_knowledgebase_description = ( isset( $_POST[ 'input_knowledgebase_description' ] ) ) ? $security -> checkvar( $_POST[ 'input_knowledgebase_description' ] ) : "" ;
	$input_knowledgebase_keywords = ( isset( $_POST[ 'input_knowledgebase_keywords' ] ) ) ? $security -> checkvar( $_POST[ 'input_knowledgebase_keywords' ] ) : "" ;
	$input_knowledgebase_answer = ( isset( $_POST[ 'input_knowledgebase_answer' ] ) ) ? $security -> checkvar( $_POST[ 'input_knowledgebase_answer' ] ) : "" ;
	$input_knowledgebase_tags = ( isset( $_POST[ 'input_knowledgebase_tags' ] ) ) ? $security -> checkvar( $_POST[ 'input_knowledgebase_tags' ] ) : "" ;
	$input_forum = ( isset( $_POST[ 'input_forum' ] ) ) ? $security -> checknum( $_POST[ 'input_forum' ] ) : "" ;
	$input_html = ( isset( $_POST[ 'input_html' ] ) ) ? $security -> checknum( $_POST[ 'input_html' ] ) : "" ;
	$input_smilies = ( isset( $_POST[ 'input_smilies' ] ) ) ? $security -> checknum( $_POST[ 'input_smilies' ] ) : "" ;
	$input_blockcode = ( isset( $_POST[ 'input_blockcode' ] ) ) ? $security -> checknum( $_POST[ 'input_blockcode' ] ) : "" ;
	$input_allow_comments = ( isset( $_POST[ 'input_allow_comments' ] ) ) ? $security -> checknum( $_POST[ 'input_allow_comments' ] ) : "" ;
	$input_url_tag = ( isset( $_POST[ 'input_url_tag' ] ) ) ? $security -> checknum( $_POST[ 'input_url_tag' ] ) : "" ;
	$input_url_get = ( isset( $_POST[ 'input_url_get' ] ) ) ? $security -> checknum( $_POST[ 'input_url_get' ] ) : "" ;
	$input_status = ( isset( $_POST[ 'input_status' ] ) ) ? $security -> checknum( $_POST[ 'input_status' ] ) : "" ;
	$input_password = ( isset( $_POST[ 'input_password' ] ) ) ? $security -> checkvar( $_POST[ 'input_password' ] ) : "" ;
	$input_fields = ( isset( $_POST[ 'input_fields' ] ) ) ? $security -> checkvararray( $_POST[ 'input_fields' ] ) : "" ;
	$input_dofileedit = ( isset( $_POST[ 'input_dofileedit' ] ) ) ? $security -> checknum( $_POST[ 'input_dofileedit' ] ) : "" ;
	$input_dopreview = ( isset( $_POST[ 'input_dopreview' ] ) ) ? $security -> checknum( $_POST[ 'input_dopreview' ] ) : "" ;
	$input_doupload = ( isset( $_POST[ 'input_doupload' ] ) ) ? $security -> checkvar( $_POST[ 'input_doupload' ] ) : "" ;
	$input_file_title = ( isset( $_POST[ 'input_file_title' ] ) ) ? $security -> checkvararray( $_POST[ 'input_file_title' ] ) : array() ;
	$input_file_description = ( isset( $_POST[ 'input_file_description' ] ) ) ? $security -> checkvararray( $_POST[ 'input_file_description' ] ) : array() ;
	$input_dofileremove = ( isset( $_POST[ 'input_dofileremove' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileremove' ] ) : "" ;
	$input_dofileedit = ( isset( $_POST[ 'input_dofileedit' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileedit' ] ) : "" ;
	$input_doeditfile = ( isset( $_POST[ 'input_doeditfile' ] ) ) ? $security -> checkvar( $_POST[ 'input_doeditfile' ] ) : "" ;
	$input_edittitle = ( isset( $_POST[ 'input_edittitle' ] ) ) ? $security -> checkvar( $_POST[ 'input_edittitle' ] ) : "" ;
	$input_editdescription = ( isset( $_POST[ 'input_editdescription' ] ) ) ? $security -> checkvar( $_POST[ 'input_editdescription' ] ) : "" ;
	$input_editid = ( isset( $_POST[ 'input_editid' ] ) ) ? $security -> checknum( $_POST[ 'input_editid' ] ) : "" ;
	$input_dopreview = ( isset( $_POST[ 'input_dopreview' ] ) ) ? $security -> checkvar( $_POST[ 'input_dopreview' ] ) : "" ;
	$input_dospellcheck = ( isset( $_POST[ 'input_dospellcheck' ] ) ) ? $security -> checkvar( $_POST[ 'input_dospellcheck' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $system -> adminhashget() != $input_security_hash ) and( $preferences[ 'website_subsessions_admin' ] ) )
	{
		$html -> login( $words_knowledgebase[ 'ERROR' ], $words_knowledgebase[ 'INVALID_SESSION' ], "index.php" );
		exit;
	}
	
	$notice = "";
	
	if( $input_doupload )
	{
		$error = "";
		
		for( $a = 0; $a < count( $_FILES[ 'input_file' ][ 'name' ] ); $a++ )
		{
			$file_name = ( isset( $_FILES[ 'input_file' ][ 'name' ][ $a ] ) ) ? $security -> checkvar( strtolower( $_FILES[ 'input_file' ][ 'name' ][ $a ] ) ) : "" ;
			$tmp_name = ( isset( $_FILES[ 'input_file' ][ 'tmp_name' ][ $a ] ) ) ? $_FILES[ 'input_file' ][ 'tmp_name' ][ $a ] : "" ;
			$file_size = ( isset( $_FILES[ 'input_file' ][ 'size' ][ $a ] ) ) ? $security -> checknum( $_FILES[ 'input_file' ][ 'size' ][ $a ] ) : "" ;
			$file_type = ( isset( $_FILES[ 'input_file' ][ 'type' ][ $a ] ) ) ? $security -> checkvar( $_FILES[ 'input_file' ][ 'type' ][ $a ] ) : "" ;
			
			if( $file_name )
			{
				$query = $database -> dbquery( "SELECT filetype_adminsize, filetype_extension FROM " . DB_PREFIX . "esselbach_ct_filetypes WHERE filetype_mime = '" . $database -> dbescape( $file_type ) . "'" );
				
				if( $database -> dbrows( $query ) )
				{
					list( $file_allowedsize, $file_extension ) = $database -> dbrow( $query );
					
					if( $file_size > $file_allowedsize )
					{
						$error = $words_knowledgebase[ 'FILE_TOO_LARGE' ] . " " . $file_allowedsize . " " . $words_knowledgebase[ 'BYTES' ];
					}
					
					if( !preg_match( "/" . $file_extension . "/i", $file_name ) )
					{
						$error = $words_knowledgebase[ 'FILETYPE_INVALID' ];
					}
				}
				else
				{
					$error = $words_knowledgebase[ 'FILETYPE_UNKNOWN' ];
				}
				
				if( !$tmp_name )
				{
					$error = $words_knowledgebase[ 'FILE_EMPTY' ];
				}
				
				if( !$error )
				{
					$file = @fopen( $tmp_name, "r" );
					
					if( $file )
					{
						$binary = fread( $file, filesize( $tmp_name ) );
						
						if( ( $file_type == "image/png" or $file_type == "image/pjpeg" or $file_type == "image/jpeg" or $file_type == "image/gif" ) and function_exists( "imagecreatefromstring" ) )
						{
							if( $preferences[ 'knowledgebase_image_width' ] )
							{
								$binary = $system -> resizeimage( $binary, $file_type, $preferences[ 'knowledgebase_image_width' ], $preferences[ 'knowledgebase_image_brandtext' ], $preferences[ 'knowledgebase_image_brandcolor' ] );
								$file_size = strlen( $binary );
							}
							
							$thumb_image = $system -> resizeimage( $binary, $file_type, $preferences[ 'knowledgebase_image_thumbwidth' ], "", "" );
							$thumb_size = strlen( $thumb_image );
							$thumb_image = $database -> dbescape( $thumb_image );
						}
						else
						{
							$thumb_image = "";
							$thumb_size = 0;
						}
						
						$binary = $database -> dbescape( $binary );
						fclose( $file );
						
						if( !$input_file_title[ $a ] )
						{
							$input_file_title[ $a ] = $file_name;
						}
						
						if( !$input_file_description[ $a ] )
						{
							$input_file_description[ $a ] = $words_knowledgebase[ 'NO_DESCRIPTION' ];
						}
						
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_knowledgebasefiles (knowledgebasefile_id, knowledgebasefile_author, knowledgebasefile_filename, knowledgebasefile_title, knowledgebasefile_description, knowledgebasefile_mime, knowledgebasefile_size, knowledgebasefile_binary, knowledgebasefile_thumbsize, knowledgebasefile_thumbimage, knowledgebasefile_inuse, knowledgebasefile_entry, knowledgebasefile_date, knowledgebasefile_views, knowledgebasefile_activity, knowledgebasefile_postip, knowledgebasefile_editip) VALUES (NULL, '" . $login_username . "', '" . $file_name . "', '" . $input_file_title[ $a ] . "', '" . $input_file_description[ $a ] . "', '" . $file_type . "', '" . $file_size . "', '" . $binary . "', '" . $thumb_size . "', '" . $thumb_image . "', '0', '0', now(), '0', now(), '" . $ipaddr . "', '" . $ipaddr . "')" );
						$notice = $words_knowledgebase[ 'UPLOAD_SUCCESSFULLY' ];
						$input_file_title[ $a ] = "";
						$input_file_description[ $a ] = "";
					}
				}
				else
				{
					$file_id = $a + 1;
					$notice = $words_knowledgebase[ 'FILE' ] . " #" . $file_id . ":<br />" . $error;
				}
			}
		}
	}
	
	if( $input_dofileremove )
	{
		$input_file = explode( "#", $input_dofileremove );
		$input_file = $security -> checknum( $input_file[ 1 ] );
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_knowledgebasefiles WHERE knowledgebasefile_author = '" . $login_username . "' AND knowledgebasefile_id = '" . $input_file . "'" );
		$notice = $words_knowledgebase[ 'FILE_REMOVED' ];
	}
	
	if( !$notice )
	{
		if( !$input_knowledgebase_question )
		{
			$notice = $words_knowledgebase[ 'KNOWLEDGEBASE_NO_QUESTION' ];
		}
		
		if( !$input_knowledgebase_answer )
		{
			$notice = $words_knowledgebase[ 'KNOWLEDGEBASE_NO_ANSWER' ];
		}
		
		if( ( $input_status == 3 ) and( !$input_password ) )
		{
			$notice = $words_knowledgebase[ 'NO_PASSWORD' ];
		}
	}
	
	if( $input_dofileedit )
	{
		$notice = "";
	}
	
	if( $input_doeditfile )
	{
		if( !$input_edittitle )
		{
			$query = dbquery( "SELECT knowledgebasefile_filename FROM " . DB_PREFIX . "esselbach_ct_knowledgebasefiles WHERE knowledgebasefile_id = '" . $input_editid . "'" );
			list( $input_edittitle ) = $database -> dbquery( $query );
			$input_edittitle = $database -> dbescape( $input_edittitle );
		}
		
		if( !$input_editdescription )
		{
			$input_editdescription = $words_knowledgebase[ 'NO_DESCRIPTION' ];
		}
		
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_knowledgebasefiles SET knowledgebasefile_title = '" . $input_edittitle . "', knowledgebasefile_description = '" . $input_editdescription . "', knowledgebasefile_editip = '" . $ipaddr . "' WHERE knowledgebasefile_author = '" . $login_username . "' AND knowledgebasefile_id = '" . $input_editid . "'" );
		$notice = $words_knowledgebase[ 'DESCRIPTION_CHANGED' ];
	}
	
	if( !$input_knowledgebase_description )
	{
		$input_knowledgebase_description = $system -> description( $input_knowledgebase_answer );
	}
	
	if( !$input_knowledgebase_keywords )
	{
		$input_knowledgebase_keywords = $system -> keywords( $input_knowledgebase_answer );
	}
	
	if( $input_dospellcheck )
	{
		if( $dictionary = @pspell_new( $preferences[ 'website_spellchecker' ] ) )
		{
			$words_array = explode( " ", $input_knowledgebase_answer );
			$input_page_spelling = "";
			$input_spell_errors = 0;
			
			foreach( $words_array as $word )
			{
				if( pspell_check( $dictionary, $word ) )
				{
					$input_page_spelling .= $word . " ";
				}
				else
				{
					$suggestions = implode( ", ", pspell_suggest( $dictionary, $word ) );
					( $suggestions ) ? $suggestions = $words_knowledgebase[ 'SUGGESTIONS' ] . ": " . $suggestions : $suggestions = $words_knowledgebase[ 'NO_SUGGESTIONS' ];
					$input_page_spelling .= "<span style=\"background-color: rgb(235, 15, 20); font-weight:bold;\" title=\"" . $suggestions . "\"><strong>" . $word . "</strong></span> ";
					$input_spell_errors++;
				}
			}
			
			$notice = $words_knowledgebase[ 'THE_SPELL_CHECKER_FOUND' ] . " " . $input_spell_errors . " " . $words_knowledgebase[ 'ERRORS' ] . ":<br /><br />" . $input_page_spelling;
		}
	}
	
	if( ( $notice ) or( $input_dopreview ) or( $input_dofileedit ) )
	{
		AdminAddNewKnowledgeBaseEntry( $notice );
	}
	else
	{
		$seo_url = ( $preferences[ 'website_mod_rewrite' ] ) ? "" : "contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] ;
		if( is_array( $input_fields ) )
		{
			$input_fields_encoded = base64_encode( $system -> stripthis( $input_fields[ 0 ] ) );
			
			for( $i = 1; $i < 24; $i++ )
			{
				$input_fields_encoded .= "|";
				
				if( isset( $input_fields[ $i ] ) )
				{
					$input_fields_encoded .= base64_encode( $system -> stripthis( $input_fields[ $i ] ) );
				}
			}
		}
		else
		{
			$input_fields_encoded = "";
		}
		
		if ( $input_blockcode )
		{
			if ( $input_url_tag )
			{
				$input_knowledgebase_answer = preg_replace( "#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1[url]\\2[/url]", $input_knowledgebase_answer );
			}
				
			if ( $input_url_get )
			{
				$input_knowledgebase_answer = $system -> geturltitles( $input_knowledgebase_answer );
			}
		}
		
		$input_knowledgebase_answer_parsed = stripslashes( $input_knowledgebase_answer );
		
		if( !$input_html )
		{
			$input_knowledgebase_answer_parsed = $system -> dechomp( $input_knowledgebase_answer_parsed );
		}
		else
		{
			$input_knowledgebase_answer_parsed = $system -> scriptex( $input_knowledgebase_answer_parsed );
		}
		
		if( $input_smilies )
		{
			$input_knowledgebase_answer_parsed = $system -> smilies( $input_knowledgebase_answer_parsed );
		}
		
		if( $input_blockcode )
		{
			$input_knowledgebase_answer_parsed = $system -> code( $input_knowledgebase_answer_parsed );
			$input_knowledgebase_answer_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=knowledgebase&amp;action=attachments&amp;id=\\1\">\\2</a>", $input_knowledgebase_answer_parsed );
			$input_knowledgebase_answer_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=knowledgebase&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_knowledgebase_answer_parsed );
			$input_knowledgebase_answer_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"" . $seo_url . "knowledgebase" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\" title=\"" . $words_knowledgebase[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"contentteller.php?ct=knowledgebase&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_knowledgebase_answer_parsed );
		}
		
		$input_knowledgebase_answer_parsed = $database -> dbescape( $input_knowledgebase_answer_parsed );
		$input_knowledgebase_question = htmlspecialchars( $input_knowledgebase_question );
		
		if( !$input_knowledgebase_seo )
		{
			$input_knowledgebase_seo = $input_knowledgebase_question;
		}
		
		$input_knowledgebase_seo = $system -> doseo( $input_knowledgebase_seo );
		$query = $database -> dbquery( "SELECT COUNT(knowledgebase_id) FROM " . DB_PREFIX . "esselbach_ct_knowledgebase WHERE knowledgebase_seo = '" . $input_knowledgebase_seo . "'" );
		list( $seo_entries ) = $database -> dbrow( $query );
		
		if( $seo_entries )
		{
			$input_knowledgebase_seo .= "_" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
		}
		
		if( !$input_knowledgebase_tags and $preferences[ 'knowledgebase_automated_tags' ] )
		{
			$input_knowledgebase_tags = $system -> tags( $input_knowledgebase_question );
		}
		
		$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_knowledgebase (knowledgebase_id, knowledgebase_author, knowledgebase_website, knowledgebase_category, knowledgebase_question, knowledgebase_seo, knowledgebase_rawanswer, knowledgebase_answer, knowledgebase_description, knowledgebase_keywords, knowledgebase_tags, knowledgebase_comments, knowledgebase_allowcomments, knowledgebase_thread, knowledgebase_html, knowledgebase_smilies, knowledgebase_code, knowledgebase_status, knowledgebase_password, knowledgebase_date, knowledgebase_fields, knowledgebase_views, knowledgebase_rating, knowledgebase_votes, knowledgebase_activity, knowledgebase_postip, knowledgebase_editip, knowledgebase_editadmin) VALUES (NULL, '" . $login_username . "', '" . $input_website . "', '" . $input_category . "', '" . $input_knowledgebase_question . "', '" . $input_knowledgebase_seo . "', '" . $input_knowledgebase_answer . "', '" . $input_knowledgebase_answer_parsed . "', '" . $input_knowledgebase_description . "', '" . $input_knowledgebase_keywords . "', '" . $input_knowledgebase_tags . "', '0', '" . $input_allow_comments . "', '0', '" . $input_html . "', '" . $input_smilies . "', '" . $input_blockcode . "', '" . $input_status . "', '" . $input_password . "', now(), '" . $input_fields_encoded . "', '0', '0', '0', now(), '" . $ipaddr . "', '" . $ipaddr . "', '" . $login_username . "')" );
		$input_page = $database -> dblastinsert();
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_knowledgebasefiles SET knowledgebasefile_inuse = '1', knowledgebasefile_entry = '" . $input_page . "', knowledgebasefile_activity = now(), knowledgebasefile_editip = '" . $ipaddr . "' WHERE knowledgebasefile_author = '" . $login_username . "' AND knowledgebasefile_inuse = '0'" );
		
		if( $preferences[ 'knowledgebase_forum_comments' ] )
		{
			if( $input_forum )
			{
				$link = $preferences[ 'website_url' ] . "/" . $seo_url . "knowledgebase" . $preferences[ 'param_action' ] . "entry" . $preferences[ 'param_page' ] . $input_knowledgebase_seo . ".html";
				
				if( $preferences[ 'website_uwrapper_loginname' ] )
				{
					$query = $database -> dbquery( "SELECT user_loginname FROM " . DB_PREFIX . "esselbach_ct_users WHERE user_name = '" . $login_username . "' AND user_status = '2'" );
					list( $loginname ) = $database -> dbrow( $query );
					$userid = $uwrapper -> getuserid( $loginname );
					$threadid = $uwrapper -> addthread( $input_knowledgebase_question, $input_knowledgebase_description, $link, $input_forum, $loginname, $userid );
				}
				else
				{
					$userid = $uwrapper -> getuserid( $login_username );
					$threadid = $uwrapper -> addthread( $input_knowledgebase_question, $input_knowledgebase_description, $link, $input_forum, $login_username, $userid );
				}
				
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_knowledgebase SET knowledgebase_thread = '" . $threadid . "' WHERE knowledgebase_id = '" . $input_page . "'" );
				
				if( $userid )
				{
					$uwrapper -> addpost( $login_username );
				}
			}
		}
		
		if( $input_knowledgebase_tags )
		{
			$tags = explode( ",", $input_knowledgebase_tags );
			
			foreach( $tags as $tag )
			{
				$tag_seo = $system -> doseo( $tag );
				$query = $database -> dbquery( "SELECT knowledgebasetag_id FROM " . DB_PREFIX . "esselbach_ct_knowledgebasetags WHERE knowledgebasetag_tag = '" . $tag . "' AND (knowledgebasetag_website = '0' AND knowledgebasetag_website = '" . $input_website . "')" );
				
				if( $database -> dbrows( $query ) )
				{
					$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_knowledgebasetags SET knowledgebasetag_count = knowledgebasetag_count + 1, knowledgebasetag_date = now() WHERE knowledgebasetag_tag = '" . $tag . "' AND (knowledgebasetag_website = '0' AND knowledgebasetag_website = '" . $input_website . "')" );
				}
				else
				{
					$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_knowledgebasetags (knowledgebasetag_id, knowledgebasetag_website, knowledgebasetag_tag, knowledgebasetag_seo, knowledgebasetag_count, knowledgebasetag_date) VALUES (NULL, '" . $input_website . "', '" . $tag . "', '" . $tag_seo . "', '1', now())" );
				}
			}
		}
		
		$html -> login( $words_knowledgebase[ 'ADD_NEW_ENTRY' ], $words_knowledgebase[ 'ENTRY_ADDED' ], "index.php?action=manageknowledgebase" );
	}
}
?>