<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 2                                                  |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage News
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminDoAddNewStory
 * A function to add a new news story to the database
 * @author Philipp Louis Esselbach
 */
function AdminDoAddNewStory()
{
	global $database, $security, $system, $html, $ipaddr, $login_username, $preferences, $uwrapper, $words_news;
	$input_website = ( isset( $_POST[ 'input_website' ] ) ) ? $security -> checknum( $_POST[ 'input_website' ] ) : "" ;
	$input_channels = ( isset( $_POST[ 'input_channels' ] ) ) ? $security -> checkvararray( $_POST[ 'input_channels' ] ) : "" ;
	$input_teaserimage = ( isset( $_POST[ 'input_teaserimage' ] ) ) ? $security -> checknum( $_POST[ 'input_teaserimage' ] ) : 0 ;
	$input_top = ( isset( $_POST[ 'input_top' ] ) ) ? $security -> checknum( $_POST[ 'input_top' ] ) : 0 ;
	$input_year = ( isset( $_POST[ 'input_year' ] ) ) ? $security -> checknum( $_POST[ 'input_year' ] ) : "" ;
	$input_month = ( isset( $_POST[ 'input_month' ] ) ) ? $security -> checknum( $_POST[ 'input_month' ] ) : "" ;
	$input_day = ( isset( $_POST[ 'input_day' ] ) ) ? $security -> checknum( $_POST[ 'input_day' ] ) : "" ;
	$input_hour = ( isset( $_POST[ 'input_hour' ] ) ) ? $security -> checknum( $_POST[ 'input_hour' ] ) : "" ;
	$input_minute = ( isset( $_POST[ 'input_minute' ] ) ) ? $security -> checknum( $_POST[ 'input_minute' ] ) : "" ;
	$input_second = ( isset( $_POST[ 'input_second' ] ) ) ? $security -> checknum( $_POST[ 'input_second' ] ) : "" ;
	$input_now = ( isset( $_POST[ 'input_now' ] ) ) ? $security -> checknum( $_POST[ 'input_now' ] ) : "" ;
	$input_expire_year = ( isset( $_POST[ 'input_expire_year' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_year' ] ) : "" ;
	$input_expire_month = ( isset( $_POST[ 'input_expire_month' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_month' ] ) : "" ;
	$input_expire_day = ( isset( $_POST[ 'input_expire_day' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_day' ] ) : "" ;
	$input_expire_hour = ( isset( $_POST[ 'input_expire_hour' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_hour' ] ) : "" ;
	$input_expire_minute = ( isset( $_POST[ 'input_expire_minute' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_minute' ] ) : "" ;
	$input_expire_second = ( isset( $_POST[ 'input_expire_second' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_second' ] ) : "" ;
	$input_expire_never = ( isset( $_POST[ 'input_expire_never' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_never' ] ) : "" ;
	$input_newsstory_title = ( isset( $_POST[ 'input_newsstory_title' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_title' ] ) : "" ;
	$input_newsstory_seo = ( isset( $_POST[ 'input_newsstory_seo' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_seo' ] ) : "" ;
	$input_newsstory_source = ( isset( $_POST[ 'input_newsstory_source' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_source' ] ) : "" ;
	$input_newsstory_description = ( isset( $_POST[ 'input_newsstory_description' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_description' ] ) : "" ;
	$input_newsstory_keywords = ( isset( $_POST[ 'input_newsstory_keywords' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_keywords' ] ) : "" ;
	$input_newsstory_story = ( isset( $_POST[ 'input_newsstory_story' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_story' ] ) : "" ;
	$input_newsstory_extendedstory = ( isset( $_POST[ 'input_newsstory_extendedstory' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_extendedstory' ] ) : "" ;
	$input_newsstory_link = ( isset( $_POST[ 'input_newsstory_link' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_link' ] ) : "" ;
	$input_newsstory_tags = ( isset( $_POST[ 'input_newsstory_tags' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_tags' ] ) : "" ;
	$input_newsstory_trackback = ( isset( $_POST[ 'input_newsstory_trackback' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_trackback' ] ) : "" ;
	$input_forum = ( isset( $_POST[ 'input_forum' ] ) ) ? $security -> checknum( $_POST[ 'input_forum' ] ) : "" ;
	$input_html = ( isset( $_POST[ 'input_html' ] ) ) ? $security -> checknum( $_POST[ 'input_html' ] ) : "" ;
	$input_smilies = ( isset( $_POST[ 'input_smilies' ] ) ) ? $security -> checknum( $_POST[ 'input_smilies' ] ) : "" ;
	$input_blockcode = ( isset( $_POST[ 'input_blockcode' ] ) ) ? $security -> checknum( $_POST[ 'input_blockcode' ] ) : "" ;
	$input_allow_comments = ( isset( $_POST[ 'input_allow_comments' ] ) ) ? $security -> checknum( $_POST[ 'input_allow_comments' ] ) : "" ;
	$input_frontpage = ( isset( $_POST[ 'input_frontpage' ] ) ) ? $security -> checknum( $_POST[ 'input_frontpage' ] ) : "" ;
	$input_url_tag = ( isset( $_POST[ 'input_url_tag' ] ) ) ? $security -> checknum( $_POST[ 'input_url_tag' ] ) : "" ;
	$input_url_get = ( isset( $_POST[ 'input_url_get' ] ) ) ? $security -> checknum( $_POST[ 'input_url_get' ] ) : "" ;
	$input_status = ( isset( $_POST[ 'input_status' ] ) ) ? $security -> checknum( $_POST[ 'input_status' ] ) : "" ;
	$input_password = ( isset( $_POST[ 'input_password' ] ) ) ? $security -> checkvar( $_POST[ 'input_password' ] ) : "" ;
	$input_poll_question = ( isset( $_POST[ 'input_poll_question' ] ) ) ? $security -> checkvar( $_POST[ 'input_poll_question' ] ) : "" ;
	$input_poll_choice = ( isset( $_POST[ 'input_poll_choice' ] ) ) ? $security -> checknum( $_POST[ 'input_poll_choice' ] ) : "" ;
	$input_poll_options = ( isset( $_POST[ 'input_poll_options' ] ) ) ? $security -> checkvararray( $_POST[ 'input_poll_options' ] ) : "" ;
	$input_fields = ( isset( $_POST[ 'input_fields' ] ) ) ? $security -> checkvararray( $_POST[ 'input_fields' ] ) : "" ;
	$input_doupload = ( isset( $_POST[ 'input_doupload' ] ) ) ? $security -> checkvar( $_POST[ 'input_doupload' ] ) : "" ;
	$input_doteaserupload = ( isset( $_POST[ 'input_doteaserupload' ] ) ) ? $security -> checkvar( $_POST[ 'input_doteaserupload' ] ) : "" ;
	$input_file_title = ( isset( $_POST[ 'input_file_title' ] ) ) ? $security -> checkvararray( $_POST[ 'input_file_title' ] ) : array() ;
	$input_file_description = ( isset( $_POST[ 'input_file_description' ] ) ) ? $security -> checkvararray( $_POST[ 'input_file_description' ] ) : array() ;
	$input_dofileremove = ( isset( $_POST[ 'input_dofileremove' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileremove' ] ) : "" ;
	$input_dofileedit = ( isset( $_POST[ 'input_dofileedit' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileedit' ] ) : "" ;
	$input_doeditfile = ( isset( $_POST[ 'input_doeditfile' ] ) ) ? $security -> checkvar( $_POST[ 'input_doeditfile' ] ) : "" ;
	$input_edittitle = ( isset( $_POST[ 'input_edittitle' ] ) ) ? $security -> checkvar( $_POST[ 'input_edittitle' ] ) : "" ;
	$input_editdescription = ( isset( $_POST[ 'input_editdescription' ] ) ) ? $security -> checkvar( $_POST[ 'input_editdescription' ] ) : "" ;
	$input_editid = ( isset( $_POST[ 'input_editid' ] ) ) ? $security -> checknum( $_POST[ 'input_editid' ] ) : "" ;
	$input_dopreview = ( isset( $_POST[ 'input_dopreview' ] ) ) ? $security -> checkvar( $_POST[ 'input_dopreview' ] ) : "" ;
	$input_dospellcheck = ( isset( $_POST[ 'input_dospellcheck' ] ) ) ? $security -> checkvar( $_POST[ 'input_dospellcheck' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $system -> adminhashget() != $input_security_hash ) and( $preferences[ 'website_subsessions_admin' ] ) )
	{
		$html -> login( $words_news[ 'ERROR' ], $words_news[ 'INVALID_SESSION' ], "index.php" );
		exit;
	}
	
	$notice = "";
	
	if( $input_doupload )
	{
		$error = "";
		
		for( $a = 0; $a < count( $_FILES[ 'input_file' ][ 'name' ] ); $a++ )
		{
			$file_name = ( isset( $_FILES[ 'input_file' ][ 'name' ][ $a ] ) ) ? $security -> checkvar( strtolower( $_FILES[ 'input_file' ][ 'name' ][ $a ] ) ) : "" ;
			$tmp_name = ( isset( $_FILES[ 'input_file' ][ 'tmp_name' ][ $a ] ) ) ? $_FILES[ 'input_file' ][ 'tmp_name' ][ $a ] : "" ;
			$file_size = ( isset( $_FILES[ 'input_file' ][ 'size' ][ $a ] ) ) ? $security -> checknum( $_FILES[ 'input_file' ][ 'size' ][ $a ] ) : "" ;
			$file_type = ( isset( $_FILES[ 'input_file' ][ 'type' ][ $a ] ) ) ? $security -> checkvar( $_FILES[ 'input_file' ][ 'type' ][ $a ] ) : "" ;
			
			if( $file_name )
			{
				$query = $database -> dbquery( "SELECT filetype_adminsize, filetype_extension FROM " . DB_PREFIX . "esselbach_ct_filetypes WHERE filetype_mime = '" . $database -> dbescape( $file_type ) . "'" );
				
				if( $database -> dbrows( $query ) )
				{
					list( $file_allowedsize, $file_extension ) = $database -> dbrow( $query );
					
					if( $file_size > $file_allowedsize )
					{
						$error = $words_news[ 'FILE_TOO_LARGE' ] . " " . $file_allowedsize . " " . $words_news[ 'BYTES' ];
					}
					
					if( !preg_match( "/" . $file_extension . "/i", $file_name ) )
					{
						$error = $words_news[ 'FILETYPE_INVALID' ];
					}
				}
				else
				{
					$error = $words_news[ 'FILETYPE_UNKNOWN' ];
				}
				
				if( !$tmp_name )
				{
					$error = $words_news[ 'FILE_EMPTY' ];
				}
				
				if( !$error )
				{
					$file = @fopen( $tmp_name, "r" );
					
					if( $file )
					{
						$binary = fread( $file, filesize( $tmp_name ) );
						
						if( ( $file_type == "image/png" or $file_type == "image/pjpeg" or $file_type == "image/jpeg" or $file_type == "image/gif" ) and function_exists( "imagecreatefromstring" ) )
						{
							if( $preferences[ 'news_image_width' ] )
							{
								$binary = $system -> resizeimage( $binary, $file_type, $preferences[ 'news_image_width' ], $preferences[ 'news_image_brandtext' ], $preferences[ 'news_image_brandcolor' ] );
								$file_size = strlen( $binary );
							}
							
							$thumb_image = $system -> resizeimage( $binary, $file_type, $preferences[ 'news_image_thumbwidth' ], "", "" );
							$thumb_size = strlen( $thumb_image );
							$thumb_image = $database -> dbescape( $thumb_image );
						}
						else
						{
							$thumb_image = "";
							$thumb_size = 0;
						}
						
						$binary = $database -> dbescape( $binary );
						fclose( $file );
						
						if( !$input_file_title[ $a ] )
						{
							$input_file_title[ $a ] = $file_name;
						}
						
						if( !$input_file_description[ $a ] )
						{
							$input_file_description[ $a ] = $words_news[ 'NO_DESCRIPTION' ];
						}
						
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newsfiles (newsfile_id, newsfile_author, newsfile_filename, newsfile_title, newsfile_description, newsfile_mime, newsfile_size, newsfile_binary, newsfile_thumbsize, newsfile_thumbimage, newsfile_inuse, newsfile_page, newsfile_date, newsfile_views, newsfile_activity, newsfile_postip, newsfile_editip) VALUES (NULL, '" . $login_username . "', '" . $file_name . "', '" . $input_file_title[ $a ] . "', '" . $input_file_description[ $a ] . "', '" . $file_type . "', '" . $file_size . "', '" . $binary . "', '" . $thumb_size . "', '" . $thumb_image . "', '0', '0', now(), '0', now(), '" . $ipaddr . "', '" . $ipaddr . "')" );
						$notice = $words_news[ 'UPLOAD_SUCCESSFULLY' ];
						$input_file_title[ $a ] = "";
						$input_file_description[ $a ] = "";
					}
				}
				else
				{
					$file_id = $a + 1;
					$notice = $words_news[ 'FILE' ] . " #" . $file_id . ":<br />" . $error;
				}
			}
		}
	}
	
	if( $input_doteaserupload )
	{
		$file_name = ( isset( $_FILES[ 'input_teaserfile' ][ 'name' ] ) ) ? $security -> checkvar( strtolower( $_FILES[ 'input_teaserfile' ][ 'name' ] ) ) : "" ;
		$tmp_name = ( isset( $_FILES[ 'input_teaserfile' ][ 'tmp_name' ] ) ) ? $_FILES[ 'input_teaserfile' ][ 'tmp_name' ] : "" ;
		$file_size = ( isset( $_FILES[ 'input_teaserfile' ][ 'size' ] ) ) ? $security -> checknum( $_FILES[ 'input_teaserfile' ][ 'size' ] ) : "" ;
		$file_type = ( isset( $_FILES[ 'input_teaserfile' ][ 'type' ] ) ) ? $security -> checkvar( $_FILES[ 'input_teaserfile' ][ 'type' ] ) : "" ;
		$query = $database -> dbquery( "SELECT filetype_adminsize, filetype_extension FROM " . DB_PREFIX . "esselbach_ct_filetypes WHERE filetype_mime = '" . $file_type . "' AND filetype_isimage = '1'" );
		
		if( $database -> dbrows( $query ) )
		{
			list( $file_allowedsize, $file_extension ) = $database -> dbrow( $query );
			
			if( $file_size > $file_allowedsize )
			{
				$notice = $words_news[ 'FILE_TOO_LARGE' ] . " " . $file_allowedsize . " " . $words_news[ 'BYTES' ];
			}
			
			if( !preg_match( "/" . $file_extension . "/i", $file_name ) )
			{
				$notice = $words_news[ 'FILETYPE_INVALID' ];
			}
		}
		else
		{
			$notice = $words_news[ 'FILETYPE_NOT_ALLOWED_IMAGE' ];
		}
		
		if( !$tmp_name )
		{
			$notice = $words_news[ 'FILE_EMPTY' ];
		}
		
		$file = @fopen( $tmp_name, "r" );
		
		if( $file and !$notice )
		{
			$binary = fread( $file, filesize( $tmp_name ) );
			
			if( ( $file_type == "image/png" or $file_type == "image/pjpeg" or $file_type == "image/jpeg" or $file_type == "image/gif" ) and function_exists( "imagecreatefromstring" ) )
			{
				if( $preferences[ 'news_image_teaserwidth' ] )
				{
					$teaserwidth = $preferences[ 'news_image_teaserwidth' ];
				}
				else
				{
					$teaserwidth = 20;
				}
				
				$teaser_image = $system -> resizeimage( $binary, $file_type, $teaserwidth, "", "" );
				$teaser_size = strlen( $teaser_image );
				$teaser_image = $database -> dbescape( $teaser_image );
			}
			else
			{
				$teaser_size = $file_size;
				$teaser_image = $database -> dbescape( $binary );
			}
			
			fclose( $file );
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newsteaserimages (newsteaserimage_id, newsteaserimage_author, newsteaserimage_filename, newsteaserimage_mime, newsteaserimage_size, newsteaserimage_binary, newsteaserimage_default, newsteaserimage_story, newsteaserimage_ip) VALUES (NULL, '" . $login_username . "', '" . $file_name . "', '" . $file_type . "', '" . $teaser_size . "', '" . $teaser_image . "', '0', '0', '" . $ipaddr . "')" );
			$notice = $words_news[ 'TEASER_IMAGE_ADDED' ];
		}
	}
	
	if( $input_dofileremove )
	{
		$input_file = explode( "#", $input_dofileremove );
		$input_file = $security -> checknum( $input_file[ 1 ] );
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_newsfiles WHERE newsfile_author = '" . $login_username . "' AND newsfile_id = '" . $input_file . "'" );
		$notice = $words_news[ 'FILE_REMOVED' ];
	}
	
	if( !$notice )
	{
		if( !$input_newsstory_title )
		{
			$notice = $words_news[ 'NEWS_NO_TITLE' ];
		}
		
		if( !$input_newsstory_story )
		{
			$notice = $words_news[ 'NEWS_NO_STORY' ];
		}
		
		if( $preferences[ 'news_start_expire_date' ] )
		{
			if( !checkdate( $input_month, $input_day, $input_year ) or !checkdate( $input_expire_month, $input_expire_day, $input_expire_year ) )
			{
				$notice = $words_news[ 'INVALID_DATE' ];
			}
		}
		
		if( ( $input_status == 3 ) and( !$input_password ) )
		{
			$notice = $words_news[ 'NO_PASSWORD' ];
		}
	}
	
	if( $input_dofileedit )
	{
		$notice = "";
	}
	
	if( $input_doeditfile )
	{
		if( !$input_edittitle )
		{
			$query = dbquery( "SELECT newsfile_filename FROM " . DB_PREFIX . "esselbach_ct_newsfiles WHERE newsfile_id = '" . $input_editid . "'" );
			list( $input_edittitle ) = $database -> dbquery( $query );
			$input_edittitle = $database -> dbescape( $input_edittitle );
		}
		
		if( !$input_editdescription )
		{
			$input_editdescription = $words_news[ 'NO_DESCRIPTION' ];
		}
		
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newsfiles SET newsfile_title = '" . $input_edittitle . "', newsfile_description = '" . $input_editdescription . "', newsfile_editip = '" . $ipaddr . "' WHERE newsfile_author = '" . $login_username . "' AND newsfile_id = '" . $input_editid . "'" );
		$notice = $words_news[ 'DESCRIPTION_CHANGED' ];
	}
	
	if( !$input_newsstory_description )
	{
		$input_newsstory_description = $system -> description( $input_newsstory_story );
	}
	
	if( !$input_newsstory_keywords )
	{
		$input_newsstory_keywords = $system -> keywords( $input_newsstory_story );
	}
	
	if( $input_dospellcheck )
	{
		if( $dictionary = @pspell_new( $preferences[ 'website_spellchecker' ] ) )
		{
			$words_array = explode( " ", $input_newsstory_story . "\n" . $input_newsstory_extendedstory );
			$input_page_spelling = "";
			$input_spell_errors = 0;
			
			foreach( $words_array as $word )
			{
				if( pspell_check( $dictionary, $word ) )
				{
					$input_page_spelling .= $word . " ";
				}
				else
				{
					$suggestions = implode( ", ", pspell_suggest( $dictionary, $word ) );
					( $suggestions ) ? $suggestions = $words_news[ 'SUGGESTIONS' ] . ": " . $suggestions : $suggestions = $words_news[ 'NO_SUGGESTIONS' ];
					$input_page_spelling .= "<span style=\"background-color: rgb(235, 15, 20); font-weight:bold;\" title=\"" . $suggestions . "\"><strong>" . $word . "</strong></span> ";
					$input_spell_errors++;
				}
			}
			
			$notice = $words_news[ 'THE_SPELL_CHECKER_FOUND' ] . " " . $input_spell_errors . " " . $words_news[ 'ERRORS' ] . ":<br /><br />" . $input_page_spelling;
		}
	}
		
	if( ( $notice ) or( $input_dopreview ) or( $input_dofileedit ) )
	{
		AdminAddNewStory( $notice );
	}
	else
	{
		$seo_url = ( $preferences[ 'website_mod_rewrite' ] ) ? "" : "contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] ;
	
		if( is_array( $input_channels ) )
		{
			$input_channels_list = implode( ",", $input_channels );
		}
		else
		{
			$input_channels_list = "";
		}
		
		if( $input_poll_question )
		{
			$input_poll = base64_encode( $system -> stripthis( $input_poll_question ) ) . "|" . $input_poll_choice;
			
			for( $i = 1; $i < 21; $i++ )
			{
				$input_poll .= "|" . base64_encode( $system -> stripthis( $input_poll_options[ $i ] ) );
			}
		}
		else
		{
			$input_poll = "";
		}
		
		if( is_array( $input_fields ) )
		{
			$input_fields_encoded = base64_encode( $system -> stripthis( $input_fields[ 0 ] ) );
			
			for( $i = 1; $i < 24; $i++ )
			{
				$input_fields_encoded .= "|";
				
				if( isset( $input_fields[ $i ] ) )
				{
					$input_fields_encoded .= base64_encode( $system -> stripthis( $input_fields[ $i ] ) );
				}
			}
		}
		else
		{
			$input_fields_encoded = "";
		}

		if ( $input_blockcode )
		{
			if ( $input_url_tag )
			{
				$input_newsstory_story = preg_replace( "#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1[url]\\2[/url]", $input_newsstory_story );
				$input_newsstory_extendedstory = preg_replace( "#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1[url]\\2[/url]", $input_newsstory_extendedstory );	
			}
				
			if ( $input_url_get )
			{
				$input_newsstory_story = $system -> geturltitles( $input_newsstory_story );
				$input_newsstory_extendedstory = $system -> geturltitles( $input_newsstory_extendedstory );
			}
		}
	
		$input_newsstory_story_parsed = stripslashes( $input_newsstory_story );
		$input_newsstory_extendedstory_parsed = stripslashes( $input_newsstory_extendedstory );
		
		if( !$input_html )
		{
			$input_newsstory_story_parsed = $system -> dechomp( $input_newsstory_story_parsed );
			$input_newsstory_extendedstory_parsed = $system -> dechomp( $input_newsstory_extendedstory_parsed );
		}
		else
		{
			$input_newsstory_story_parsed = $system -> scriptex( $input_newsstory_story_parsed );
			$input_newsstory_extendedstory_parsed = $system -> scriptex( $input_newsstory_extendedstory_parsed );
		}
		
		if( $input_smilies )
		{
			$input_newsstory_story_parsed = $system -> smilies( $input_newsstory_story_parsed );
			$input_newsstory_extendedstory_parsed = $system -> smilies( $input_newsstory_extendedstory_parsed );
		}
		
		if( $input_blockcode )
		{	
			$input_newsstory_story_parsed = $system -> code( $input_newsstory_story_parsed );
			$input_newsstory_extendedstory_parsed = $system -> code( $input_newsstory_extendedstory_parsed );
			$input_newsstory_story_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=news&amp;action=attachments&amp;id=\\1\">\\2</a>", $input_newsstory_story_parsed );
			$input_newsstory_story_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=news&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_newsstory_story_parsed );
			$input_newsstory_story_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"" . $seo_url . "news" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\" title=\"" . $words_news[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"contentteller.php?ct=news&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_newsstory_story_parsed );
			$input_newsstory_extendedstory_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=news&amp;action=attachments&amp;id=\\1\">\\2</a>", $input_newsstory_extendedstory_parsed );
			$input_newsstory_extendedstory_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=news&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_newsstory_extendedstory_parsed );
			$input_newsstory_extendedstory_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"" . $seo_url . "news" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\" title=\"" . $words_news[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"contentteller.php?ct=news&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_newsstory_extendedstory_parsed );
		}
		
		$input_newsstory_story_parsed = $database -> dbescape( $input_newsstory_story_parsed );
		$input_newsstory_extendedstory_parsed = $database -> dbescape( $input_newsstory_extendedstory_parsed );
		
		if( $preferences[ 'news_start_expire_date' ] )
		{
			if( $input_now )
			{
				$input_startdate = date( "Y-m-d H:i:s", mktime() );
			}
			else
			{
				$input_startdate = date( "Y-m-d H:i:s", mktime( $input_hour, $input_minute, $input_second, $input_month, $input_day, $input_year ) );
			}
			
			$input_expiredate = date( "Y-m-d H:i:s", mktime( $input_expire_hour, $input_expire_minute, $input_expire_second, $input_expire_month, $input_expire_day, $input_expire_year ) );
		}
		else
		{
			$input_startdate = date( "Y-m-d H:i:s", mktime() );
			$input_expiredate = date( "Y-m-d H:i:s", mktime() );
			$input_expire_never = 1;
		}
		
		if( !$input_newsstory_seo )
		{
			$input_newsstory_seo = $input_newsstory_title;
		}
		
		$input_newsstory_seo = $system -> doseo( $input_newsstory_seo );
		$query = $database -> dbquery( "SELECT COUNT(newsstory_id) FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE newsstory_seo = '" . $input_newsstory_seo . "'" );
		list( $seo_stories ) = $database -> dbrow( $query );
		
		if( $seo_stories )
		{
			$input_newsstory_seo .= "_" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
		}
		
		if( !$input_newsstory_tags and $preferences[ 'news_automated_tags' ] )
		{
			$input_newsstory_tags = $system -> tags( $input_newsstory_title );
		}
		
		$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newsstories (newsstory_id, newsstory_author, newsstory_website, newsstory_channels, newsstory_title, newsstory_seo, newsstory_rawstory, newsstory_story, newsstory_rawextendedstory, newsstory_extendedstory, newsstory_link, newsstory_description, newsstory_keywords, newsstory_tags, newsstory_teaser, newsstory_comments, newsstory_allowcomments, newsstory_thread, newsstory_frontpage, newsstory_html, newsstory_smilies, newsstory_code, newsstory_status, newsstory_password, newsstory_date, newsstory_startdate, newsstory_expiredate, newsstory_neverexpire, newsstory_poll, newsstory_pollresults, newsstory_fields, newsstory_sticky, newsstory_views, newsstory_rating, newsstory_votes, newsstory_source, newsstory_sourceid, newsstory_activity, newsstory_postip, newsstory_editip, newsstory_editadmin) VALUES (NULL, '" . $login_username . "', '" . $input_website . "', '" . $input_channels_list . "', '" . $input_newsstory_title . "', '" . $input_newsstory_seo . "', '" . $input_newsstory_story . "', '" . $input_newsstory_story_parsed . "', '" . $input_newsstory_extendedstory . "', '" . $input_newsstory_extendedstory_parsed . "', '" . $input_newsstory_link . "', '" . $input_newsstory_description . "', '" . $input_newsstory_keywords . "', '" . $input_newsstory_tags . "', '" . $input_teaserimage . "', '0', '" . $input_allow_comments . "', '0', '" . $input_frontpage . "', '" . $input_html . "', '" . $input_smilies . "', '" . $input_blockcode . "', '" . $input_status . "', '" . $input_password . "', now(), '" . $input_startdate . "', '" . $input_expiredate . "', '" . $input_expire_never . "', '" . $input_poll . "', '', '" . $input_fields_encoded . "', '" . $input_top . "', '0', '0', '0', '" . $input_newsstory_source . "', '0', now(), '" . $ipaddr . "', '" . $ipaddr . "', '" . $login_username . "')" );
		$input_page = $database -> dblastinsert();
		
		if( $preferences[ 'news_forum_comments' ] )
		{
			if( $input_forum )
			{
				$link = $preferences[ 'website_url' ] . "/" . $seo_url . "news" . $preferences[ 'param_action' ] . "story" . $preferences[ 'param_page' ] . $input_newsstory_seo . ".html";
				
				if( $preferences[ 'website_uwrapper_loginname' ] )
				{
					$query = $database -> dbquery( "SELECT user_loginname FROM " . DB_PREFIX . "esselbach_ct_users WHERE user_name = '" . $login_username . "' AND user_status = '2'" );
					list( $loginname ) = $database -> dbrow( $query );
					$userid = $uwrapper -> getuserid( $loginname );
					$threadid = $uwrapper -> addthread( $input_newsstory_title, $input_newsstory_description, $link, $input_forum, $loginname, $userid );
				}
				else
				{
					$userid = $uwrapper -> getuserid( $login_username );
					$threadid = $uwrapper -> addthread( $input_newsstory_title, $input_newsstory_description, $link, $input_forum, $login_username, $userid );
				}
				
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newsstories SET newsstory_thread = '" . $threadid . "' WHERE newsstory_id = '" . $input_page . "'" );
				
				if( $userid )
				{
					$uwrapper -> addpost( $login_username );
				}
			}
		}
		
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newsfiles SET newsfile_inuse = '1', newsfile_page = '" . $input_page . "', newsfile_activity = now(), newsfile_editip = '" . $ipaddr . "' WHERE newsfile_author = '" . $login_username . "' AND newsfile_inuse = '0'" );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newsteaserimages SET newsteaserimage_story = '" . $input_page . "' WHERE newsteaserimage_author = '" . $login_username . "' AND newsteaserimage_story = '0' AND newsteaserimage_default = '0'" );
		
		if( $preferences[ 'news_related' ] )
		{
			$news_search = substr( $input_newsstory_title, 0, 8 );
			$news_limit = $database -> dbescape( $preferences[ 'news_max_related' ] );
			$currentdate = date( "Y-m-d H:i:s", gmmktime() );
			
			if( !$news_limit )
			{
				$news_limit = 1;
			}
			else
			{
				$news_limit++;
			}
			
			$query = $database -> dbquery( "SELECT newsstory_id, newsstory_author, newsstory_title, newsstory_seo, newsstory_description, newsstory_date FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE (newsstory_title LIKE '%" . $news_search . "%') AND newsstory_status = '0' AND newsstory_website = '" . $input_website . "' AND newsstory_startdate < '" . $currentdate . "' AND newsstory_neverexpire = '1' ORDER BY newsstory_date DESC LIMIT " . intval( $news_limit ) );
			
			if( $database -> dbrows( $query ) > 1 )
			{
				while( list( $newsrelated_storyid, $newsrelated_author, $newsrelated_title, $newsrelated_seo, $newsrelated_description, $newsrelated_date ) = $database -> dbrow( $query ) )
				{
					$newsrelated_author = $database -> dbescape( $newsrelated_author );
					$newsrelated_title = $database -> dbescape( $newsrelated_title );
					$newsrelated_description = $database -> dbescape( $newsrelated_description );
					
					if( $newsrelated_storyid != $input_page )
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newsrelated (newsrelated_id, newsrelated_story, newsrelated_storyid, newsrelated_author, newsrelated_website, newsrelated_title, newsrelated_seo, newsrelated_description, newsrelated_date) VALUES (NULL, '" . $input_page . "', '" . $newsrelated_storyid . "', '" . $newsrelated_author . "', '" . $input_website . "', '" . $newsrelated_title . "', '" . $newsrelated_seo . "', '" . $newsrelated_description . "', '" . $newsrelated_date . "')" );
					}
				}
			}
		}
		
		if( $input_newsstory_tags )
		{
			$tags = explode( ",", $input_newsstory_tags );
			
			foreach( $tags as $tag )
			{
				$tag_seo = $system -> doseo( $tag );
				$query = $database -> dbquery( "SELECT newstag_id FROM " . DB_PREFIX . "esselbach_ct_newstags WHERE newstag_seo = '" . $tag_seo . "' AND (newstag_website = '0' AND newstag_website = '" . $input_website . "')" );
				
				if( $database -> dbrows( $query ) )
				{
					$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newstags SET newstag_count = newstag_count + 1, newstag_date = now() WHERE newstag_tag = '" . $tag . "' AND (newstag_website = '0' AND newstag_website = '" . $input_website . "')" );
				}
				else
				{
					$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newstags (newstag_id, newstag_website, newstag_tag, newstag_seo, newstag_count, newstag_date) VALUES (NULL, '" . $input_website . "', '" . $tag . "', '" . $tag_seo . "', '1', now())" );
				}
			}
		}
		
		if( $input_newsstory_trackback )
		{
			$params[ 'http' ][ 'method' ] = "POST";
			$params[ 'http' ][ 'header' ] = "Content-Type: application/x-www-form-urlencoded";
			$params[ 'http' ][ 'content' ] = "title=" . urlencode( $input_newsstory_title ) . "&url=" . ( $preferences[ 'website_url' ] . "/contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] . "news" . $preferences[ 'param_action' ] . "story" . $preferences[ 'param_page' ] . $input_newsstory_seo . ".html" ) . "&blog_name=" . urlencode( $preferences[ 'website_url' ] ) . "&excerpt=" . urlencode( $input_newsstory_description );
			$ping_stream = stream_context_create( $params );
			$ping = @fopen( $input_newsstory_trackback, "rb", false, $ping_stream );
			fclose( $ping );
		}
		
		$html -> login( $words_news[ 'ADD_NEW_STORY' ], $words_news[ 'STORY_ADDED' ], "index.php?action=managestories" );
	}
}
?>