<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 2                                                  |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage News
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminDoEditStory
 * A function to edit a news story in the database
 * @author Philipp Louis Esselbach
 */
function AdminDoEditStory()
{
	global $database, $security, $system, $html, $ipaddr, $login_username, $preferences, $words_news;
	$input_website = ( isset( $_POST[ 'input_website' ] ) ) ? $security -> checknum( $_POST[ 'input_website' ] ) : "" ;
	$input_channels = ( isset( $_POST[ 'input_channels' ] ) ) ? $security -> checkvararray( $_POST[ 'input_channels' ] ) : "" ;
	$input_teaserimage = ( isset( $_POST[ 'input_teaserimage' ] ) ) ? $security -> checknum( $_POST[ 'input_teaserimage' ] ) : 0 ;
	$input_top = ( isset( $_POST[ 'input_top' ] ) ) ? $security -> checknum( $_POST[ 'input_top' ] ) : 0 ;
	$input_year = ( isset( $_POST[ 'input_year' ] ) ) ? $security -> checknum( $_POST[ 'input_year' ] ) : "" ;
	$input_month = ( isset( $_POST[ 'input_month' ] ) ) ? $security -> checknum( $_POST[ 'input_month' ] ) : "" ;
	$input_day = ( isset( $_POST[ 'input_day' ] ) ) ? $security -> checknum( $_POST[ 'input_day' ] ) : "" ;
	$input_hour = ( isset( $_POST[ 'input_hour' ] ) ) ? $security -> checknum( $_POST[ 'input_hour' ] ) : "" ;
	$input_minute = ( isset( $_POST[ 'input_minute' ] ) ) ? $security -> checknum( $_POST[ 'input_minute' ] ) : "" ;
	$input_second = ( isset( $_POST[ 'input_second' ] ) ) ? $security -> checknum( $_POST[ 'input_second' ] ) : "" ;
	$input_now = ( isset( $_POST[ 'input_now' ] ) ) ? $security -> checknum( $_POST[ 'input_now' ] ) : "" ;
	$input_expire_year = ( isset( $_POST[ 'input_expire_year' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_year' ] ) : "" ;
	$input_expire_month = ( isset( $_POST[ 'input_expire_month' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_month' ] ) : "" ;
	$input_expire_day = ( isset( $_POST[ 'input_expire_day' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_day' ] ) : "" ;
	$input_expire_hour = ( isset( $_POST[ 'input_expire_hour' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_hour' ] ) : "" ;
	$input_expire_minute = ( isset( $_POST[ 'input_expire_minute' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_minute' ] ) : "" ;
	$input_expire_second = ( isset( $_POST[ 'input_expire_second' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_second' ] ) : "" ;
	$input_expire_never = ( isset( $_POST[ 'input_expire_never' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_never' ] ) : "" ;
	$input_newsstory_title = ( isset( $_POST[ 'input_newsstory_title' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_title' ] ) : "" ;
	$input_newsstory_seo = ( isset( $_POST[ 'input_newsstory_seo' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_seo' ] ) : "" ;
	$input_newsstory_source = ( isset( $_POST[ 'input_newsstory_source' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_source' ] ) : "" ;
	$input_newsstory_sourceid = ( isset( $_POST[ 'input_newsstory_sourceid' ] ) ) ? $security -> checknum( $_POST[ 'input_newsstory_sourceid' ] ) : 0 ;
	$input_newsstory_description = ( isset( $_POST[ 'input_newsstory_description' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_description' ] ) : "" ;
	$input_newsstory_keywords = ( isset( $_POST[ 'input_newsstory_keywords' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_keywords' ] ) : "" ;
	$input_newsstory_story = ( isset( $_POST[ 'input_newsstory_story' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_story' ] ) : "" ;
	$input_newsstory_extendedstory = ( isset( $_POST[ 'input_newsstory_extendedstory' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_extendedstory' ] ) : "" ;
	$input_newsstory_link = ( isset( $_POST[ 'input_newsstory_link' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_link' ] ) : "" ;
	$input_newsstory_tags = ( isset( $_POST[ 'input_newsstory_tags' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_tags' ] ) : "" ;
	$input_html = ( isset( $_POST[ 'input_html' ] ) ) ? $security -> checknum( $_POST[ 'input_html' ] ) : "" ;
	$input_smilies = ( isset( $_POST[ 'input_smilies' ] ) ) ? $security -> checknum( $_POST[ 'input_smilies' ] ) : "" ;
	$input_blockcode = ( isset( $_POST[ 'input_blockcode' ] ) ) ? $security -> checknum( $_POST[ 'input_blockcode' ] ) : "" ;
	$input_allow_comments = ( isset( $_POST[ 'input_allow_comments' ] ) ) ? $security -> checknum( $_POST[ 'input_allow_comments' ] ) : "" ;
	$input_frontpage = ( isset( $_POST[ 'input_frontpage' ] ) ) ? $security -> checknum( $_POST[ 'input_frontpage' ] ) : "" ;
	$input_url_tag = ( isset( $_POST[ 'input_url_tag' ] ) ) ? $security -> checknum( $_POST[ 'input_url_tag' ] ) : "" ;
	$input_url_get = ( isset( $_POST[ 'input_url_get' ] ) ) ? $security -> checknum( $_POST[ 'input_url_get' ] ) : "" ;
	$input_bump = ( isset( $_POST[ 'input_bump' ] ) ) ? $security -> checknum( $_POST[ 'input_bump' ] ) : "" ;
	$input_status = ( isset( $_POST[ 'input_status' ] ) ) ? $security -> checknum( $_POST[ 'input_status' ] ) : "" ;
	$input_password = ( isset( $_POST[ 'input_password' ] ) ) ? $security -> checkvar( $_POST[ 'input_password' ] ) : "" ;
	$input_poll_question = ( isset( $_POST[ 'input_poll_question' ] ) ) ? $security -> checkvar( $_POST[ 'input_poll_question' ] ) : "" ;
	$input_poll_choice = ( isset( $_POST[ 'input_poll_choice' ] ) ) ? $security -> checknum( $_POST[ 'input_poll_choice' ] ) : "" ;
	$input_poll_options = ( isset( $_POST[ 'input_poll_options' ] ) ) ? $security -> checkvararray( $_POST[ 'input_poll_options' ] ) : "" ;
	$input_fields = ( isset( $_POST[ 'input_fields' ] ) ) ? $security -> checkvararray( $_POST[ 'input_fields' ] ) : "" ;
	$input_doupload = ( isset( $_POST[ 'input_doupload' ] ) ) ? $security -> checkvar( $_POST[ 'input_doupload' ] ) : "" ;
	$input_doteaserupload = ( isset( $_POST[ 'input_doteaserupload' ] ) ) ? $security -> checkvar( $_POST[ 'input_doteaserupload' ] ) : "" ;
	$input_file_title = ( isset( $_POST[ 'input_file_title' ] ) ) ? $security -> checkvararray( $_POST[ 'input_file_title' ] ) : array() ;
	$input_file_description = ( isset( $_POST[ 'input_file_description' ] ) ) ? $security -> checkvararray( $_POST[ 'input_file_description' ] ) : array() ;
	$input_dofileremove = ( isset( $_POST[ 'input_dofileremove' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileremove' ] ) : "" ;
	$input_dofileedit = ( isset( $_POST[ 'input_dofileedit' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileedit' ] ) : "" ;
	$input_doeditfile = ( isset( $_POST[ 'input_doeditfile' ] ) ) ? $security -> checkvar( $_POST[ 'input_doeditfile' ] ) : "" ;
	$input_edittitle = ( isset( $_POST[ 'input_edittitle' ] ) ) ? $security -> checkvar( $_POST[ 'input_edittitle' ] ) : "" ;
	$input_editdescription = ( isset( $_POST[ 'input_editdescription' ] ) ) ? $security -> checkvar( $_POST[ 'input_editdescription' ] ) : "" ;
	$input_editid = ( isset( $_POST[ 'input_editid' ] ) ) ? $security -> checknum( $_POST[ 'input_editid' ] ) : "" ;
	$input_dopreview = ( isset( $_POST[ 'input_dopreview' ] ) ) ? $security -> checkvar( $_POST[ 'input_dopreview' ] ) : "" ;
	$input_dospellcheck = ( isset( $_POST[ 'input_dospellcheck' ] ) ) ? $security -> checkvar( $_POST[ 'input_dospellcheck' ] ) : "" ;
	$input_zid = ( isset( $_POST[ 'input_zid' ] ) ) ? $security -> checknum( $_POST[ 'input_zid' ] ) : "" ;
	$input_reason = ( isset( $_POST[ 'input_reason' ] ) ) ? $security -> checkvar( $_POST[ 'input_reason' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $system -> adminhashget() != $input_security_hash ) and( $preferences[ 'website_subsessions_admin' ] ) )
	{
		$html -> login( $words_news[ 'ERROR' ], $words_news[ 'INVALID_SESSION' ], "index.php" );
		exit;
	}
	
	$notice = "";
	
	if( !$input_website )
	{
		$input_website = 0;
	}
	
	if( $input_doupload )
	{
		$error = "";
		
		for( $a = 0; $a < count( $_FILES[ 'input_file' ][ 'name' ] ); $a++ )
		{
			$file_name = ( isset( $_FILES[ 'input_file' ][ 'name' ][ $a ] ) ) ? $security -> checkvar( strtolower( $_FILES[ 'input_file' ][ 'name' ][ $a ] ) ) : "" ;
			$tmp_name = ( isset( $_FILES[ 'input_file' ][ 'tmp_name' ][ $a ] ) ) ? $_FILES[ 'input_file' ][ 'tmp_name' ][ $a ] : "" ;
			$file_size = ( isset( $_FILES[ 'input_file' ][ 'size' ][ $a ] ) ) ? $security -> checknum( $_FILES[ 'input_file' ][ 'size' ][ $a ] ) : "" ;
			$file_type = ( isset( $_FILES[ 'input_file' ][ 'type' ][ $a ] ) ) ? $security -> checkvar( $_FILES[ 'input_file' ][ 'type' ][ $a ] ) : "" ;
			
			if( $file_name )
			{
				$query = $database -> dbquery( "SELECT filetype_adminsize, filetype_extension FROM " . DB_PREFIX . "esselbach_ct_filetypes WHERE filetype_mime = '" . $database -> dbescape( $file_type ) . "'" );
				
				if( $database -> dbrows( $query ) )
				{
					list( $file_allowedsize, $file_extension ) = $database -> dbrow( $query );
					
					if( $file_size > $file_allowedsize )
					{
						$error = $words_news[ 'FILE_TOO_LARGE' ] . " " . $file_allowedsize . " " . $words_news[ 'BYTES' ];
					}
					
					if( !preg_match( "/" . $file_extension . "/i", $file_name ) )
					{
						$error = $words_news[ 'FILETYPE_INVALID' ];
					}
				}
				else
				{
					$error = $words_news[ 'FILETYPE_UNKNOWN' ];
				}
				
				if( !$tmp_name )
				{
					$error = $words_news[ 'FILE_EMPTY' ];
				}
				
				if( !$error )
				{
					$file = @fopen( $tmp_name, "r" );
					
					if( $file )
					{
						$binary = fread( $file, filesize( $tmp_name ) );
						
						if( ( $file_type == "image/png" or $file_type == "image/pjpeg" or $file_type == "image/jpeg" or $file_type == "image/gif" ) and function_exists( "imagecreatefromstring" ) )
						{
							if( $preferences[ 'news_image_width' ] )
							{
								$binary = $system -> resizeimage( $binary, $file_type, $preferences[ 'news_image_width' ], $preferences[ 'news_image_brandtext' ], $preferences[ 'news_image_brandcolor' ] );
								$file_size = strlen( $binary );
							}
							
							$thumb_image = $system -> resizeimage( $binary, $file_type, $preferences[ 'news_image_thumbwidth' ], "", "" );
							$thumb_size = strlen( $thumb_image );
							$thumb_image = $database -> dbescape( $thumb_image );
						}
						else
						{
							$thumb_image = "";
							$thumb_size = 0;
						}
						
						$binary = $database -> dbescape( $binary );
						fclose( $file );
						
						if( !$input_file_title[ $a ] )
						{
							$input_file_title[ $a ] = $file_name;
						}
						
						if( !$input_file_description[ $a ] )
						{
							$input_file_description[ $a ] = $words_news[ 'NO_DESCRIPTION' ];
						}
						
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newsfiles (newsfile_id, newsfile_author, newsfile_filename, newsfile_title, newsfile_description, newsfile_mime, newsfile_size, newsfile_binary, newsfile_thumbsize, newsfile_thumbimage, newsfile_inuse, newsfile_page, newsfile_date, newsfile_views, newsfile_activity, newsfile_postip, newsfile_editip) VALUES (NULL, '" . $login_username . "', '" . $file_name . "', '" . $input_file_title[ $a ] . "', '" . $input_file_description[ $a ] . "', '" . $file_type . "', '" . $file_size . "', '" . $binary . "', '" . $thumb_size . "', '" . $thumb_image . "', '1', '" . $input_zid . "', now(), '0', now(), '" . $ipaddr . "', '" . $ipaddr . "')" );
						$notice = $words_news[ 'UPLOAD_SUCCESSFULLY' ];
						$input_file_title[ $a ] = "";
						$input_file_description[ $a ] = "";
					}
				}
				else
				{
					$file_id = $a + 1;
					$notice = $words_news[ 'FILE' ] . " #" . $file_id . ":<br />" . $error;
				}
			}
		}
	}
	
	if( $input_doteaserupload )
	{
		$file_name = ( isset( $_FILES[ 'input_teaserfile' ][ 'name' ] ) ) ? $security -> checkvar( strtolower( $_FILES[ 'input_teaserfile' ][ 'name' ] ) ) : "" ;
		$tmp_name = ( isset( $_FILES[ 'input_teaserfile' ][ 'tmp_name' ] ) ) ? $security -> checkvar( $_FILES[ 'input_teaserfile' ][ 'tmp_name' ] ) : "" ;
		$file_size = ( isset( $_FILES[ 'input_teaserfile' ][ 'size' ] ) ) ? $security -> checknum( $_FILES[ 'input_teaserfile' ][ 'size' ] ) : "" ;
		$file_type = ( isset( $_FILES[ 'input_teaserfile' ][ 'type' ] ) ) ? $security -> checkvar( $_FILES[ 'input_teaserfile' ][ 'type' ] ) : "" ;
		$query = $database -> dbquery( "SELECT filetype_adminsize, filetype_extension FROM " . DB_PREFIX . "esselbach_ct_filetypes WHERE filetype_mime = '" . $file_type . "' AND filetype_isimage = '1'" );
		
		if( $database -> dbrows( $query ) )
		{
			list( $file_allowedsize, $file_extension ) = $database -> dbrow( $query );
			
			if( $file_size > $file_allowedsize )
			{
				$notice = $words_news[ 'FILE_TOO_LARGE' ] . " " . $file_allowedsize . " " . $words_news[ 'BYTES' ];
			}
			
			if( !preg_match( "/" . $file_extension . "/i", $file_name ) )
			{
				$notice = $words_news[ 'FILETYPE_INVALID' ];
			}
		}
		else
		{
			$notice = $words_news[ 'FILETYPE_NOT_ALLOWED_IMAGE' ];
		}
		
		if( !$tmp_name )
		{
			$notice = $words_news[ 'FILE_EMPTY' ];
		}
		
		$file = @fopen( $tmp_name, "r" );
		
		if( $file )
		{
			$binary = fread( $file, filesize( $tmp_name ) );
			
			if( ( $file_type == "image/png" or $file_type == "image/pjpeg" or $file_type == "image/jpeg" or $file_type == "image/gif" ) and function_exists( "imagecreatefromstring" ) )
			{
				if( $preferences[ 'news_image_teaserwidth' ] )
				{
					$teaserwidth = $preferences[ 'news_image_teaserwidth' ];
				}
				else
				{
					$teaserwidth = 20;
				}
				
				$teaser_image = $system -> resizeimage( $binary, $file_type, $teaserwidth, "", "" );
				$teaser_size = strlen( $teaser_image );
				$teaser_image = $database -> dbescape( $teaser_image );
			}
			else
			{
				$teaser_size = $file_size;
				$teaser_image = $database -> dbescape( $binary );
			}
			
			fclose( $file );
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newsteaserimages (newsteaserimage_id, newsteaserimage_author, newsteaserimage_filename, newsteaserimage_mime, newsteaserimage_size, newsteaserimage_binary, newsteaserimage_default, newsteaserimage_story, newsteaserimage_ip) VALUES (NULL, '" . $login_username . "', '" . $file_name . "', '" . $file_type . "', '" . $teaser_size . "', '" . $teaser_image . "', '0', '" . $input_zid . "', '" . $ipaddr . "')" );
			$notice = $words_news[ 'TEASER_IMAGE_ADDED' ];
		}
	}
	
	if( $input_dofileremove )
	{
		$input_file = explode( "#", $input_dofileremove );
		$input_file = $security -> checknum( $input_file[ 1 ] );
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_newsfiles WHERE newsfile_author = '" . $login_username . "' AND newsfile_id = '" . $input_file . "'" );
		$notice = $words_news[ 'FILE_REMOVED' ];
	}
	
	if( !$notice )
	{
		if( !$input_newsstory_title )
		{
			$notice = $words_news[ 'NEWS_NO_TITLE' ];
		}
		
		if( !$input_newsstory_story )
		{
			$notice = $words_news[ 'NEWS_NO_STORY' ];
		}
		
		if( $preferences[ 'news_start_expire_date' ] )
		{
			if( !checkdate( $input_month, $input_day, $input_year ) or !checkdate( $input_expire_month, $input_expire_day, $input_expire_year ) )
			{
				$notice = $words_news[ 'INVALID_DATE' ];
			}
		}
		
		if( ( $input_status == 3 ) and( !$input_password ) )
		{
			$notice = $words_news[ 'NO_PASSWORD' ];
		}
	}
	
	if( $input_dofileedit )
	{
		$notice = "";
	}
	
	if( $input_doeditfile )
	{
		if( !$input_edittitle )
		{
			$query = dbquery( "SELECT newsfile_filename FROM " . DB_PREFIX . "esselbach_ct_newsfiles WHERE newsfile_id = '" . $input_editid . "'" );
			list( $input_edittitle ) = $database -> dbquery( $query );
			$input_edittitle = $database -> dbescape( $input_edittitle );
		}
		
		if( !$input_editdescription )
		{
			$input_editdescription = $words_news[ 'NO_DESCRIPTION' ];
		}
		
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newsfiles SET newsfile_title = '" . $input_edittitle . "', newsfile_description = '" . $input_editdescription . "', newsfile_editip = '" . $ipaddr . "' WHERE newsfile_author = '" . $login_username . "' AND newsfile_id = '" . $input_editid . "'" );
		$notice = $words_news[ 'DESCRIPTION_CHANGED' ];
	}
	
	if( !$input_newsstory_description )
	{
		$input_newsstory_description = $system -> description( $input_newsstory_story );
	}
	
	if( !$input_newsstory_keywords )
	{
		$input_newsstory_keywords = $system -> keywords( $input_newsstory_story );
	}
	
	if( $input_dospellcheck )
	{
		if( $dictionary = @pspell_new( $preferences[ 'website_spellchecker' ] ) )
		{
			$words_array = explode( " ", $input_newsstory_story . "\n" . $input_newsstory_extendedstory );
			$input_page_spelling = "";
			$input_spell_errors = 0;
			
			foreach( $words_array as $word )
			{
				if( pspell_check( $dictionary, $word ) )
				{
					$input_page_spelling .= $word . " ";
				}
				else
				{
					$suggestions = implode( ", ", pspell_suggest( $dictionary, $word ) );
					( $suggestions ) ? $suggestions = $words_news[ 'SUGGESTIONS' ] . ": " . $suggestions : $suggestions = $words_news[ 'NO_SUGGESTIONS' ];
					$input_page_spelling .= "<span style=\"background-color: rgb(235, 15, 20); font-weight:bold;\" title=\"" . $suggestions . "\"><strong>" . $word . "</strong></span> ";
					$input_spell_errors++;
				}
			}
			
			$notice = $words_news[ 'THE_SPELL_CHECKER_FOUND' ] . " " . $input_spell_errors . " " . $words_news[ 'ERRORS' ] . ":<br /><br />" . $input_page_spelling;
		}
	}
	
	if( ( $notice ) or( $input_dopreview ) or( $input_dofileedit ) )
	{
		AdminEditStory( $input_zid, $notice );
	}
	else
	{
		$seo_url = ( $preferences[ 'website_mod_rewrite' ] ) ? "" : "contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] ;
		if( $preferences[ 'news_undo' ] )
		{
			if( !$input_reason )
			{
				$input_reason = $words_news[ 'UNKNOWN' ];
			}
			
			$query = $database -> dbquery( "SELECT newsstory_author, newsstory_title, newsstory_seo, newsstory_rawstory, newsstory_rawextendedstory, newsstory_link, newsstory_description, newsstory_keywords, newsstory_poll, newsstory_fields, newsstory_startdate, newsstory_expiredate, newsstory_neverexpire, newsstory_source, newsstory_sourceid, newsstory_editadmin FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE newsstory_id = '" . $input_zid . "'" );
			list( $old_author, $old_title, $old_seo, $old_story, $old_extendedstory, $old_link, $old_description, $old_keywords, $old_poll, $old_fields, $old_startdate, $old_expiredate, $old_neverexpire, $old_source, $old_sourceid, $old_editadmin ) = $database -> dbrow( $query );
			$old_author = $database -> dbescape( $old_author );
			$old_title = $database -> dbescape( $old_title );
			$old_seo = $database -> dbescape( $old_seo );
			$old_story = $database -> dbescape( $old_story );
			$old_extendedstory = $database -> dbescape( $old_extendedstory );
			$old_link = $database -> dbescape( $old_link );
			$old_description = $database -> dbescape( $old_description );
			$old_keywords = $database -> dbescape( $old_keywords );
			$old_poll = $database -> dbescape( $old_poll );
			$old_fields = $database -> dbescape( $old_fields );
			$old_startdate = $database -> dbescape( $old_startdate );
			$old_expiredate = $database -> dbescape( $old_expiredate );
			$old_neverexpire = $database -> dbescape( $old_neverexpire );
			$old_source = $database -> dbescape( $old_source );
			$old_sourceid = $database -> dbescape( $old_sourceid );
			$old_editadmin = $database -> dbescape( $old_editadmin );
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newsstoriesundo (newsstoryundo_id, newsstoryundo_storyid, newsstoryundo_author, newsstoryundo_title, newsstoryundo_seo, newsstoryundo_story, newsstoryundo_extendedstory, newsstoryundo_link, newsstoryundo_description, newsstoryundo_keywords, newsstoryundo_date, newsstoryundo_startdate, newsstoryundo_expiredate, newsstoryundo_neverexpire, newsstoryundo_poll, newsstoryundo_fields, newsstoryundo_source, newsstoryundo_sourceid, newsstoryundo_editip, newsstoryundo_editadmin, newsstoryundo_editreason) VALUES (NULL, '" . $input_zid . "', '" . $old_author . "', '" . $old_title . "', '" . $old_seo . "', '" . $old_story . "', '" . $old_extendedstory . "', '" . $old_link . "', '" . $old_description . "', '" . $old_keywords . "', now(), '" . $old_startdate . "', '" . $old_expiredate . "', '" . $old_neverexpire . "', '" . $old_poll . "', '" . $old_fields . "', '" . $old_source . "', '" . $old_sourceid . "', '" . $ipaddr . "', '" . $old_editadmin . "', '" . $input_reason . "')" );
		}
		
		if( is_array( $input_channels ) )
		{
			$input_channels_list = implode( ",", $input_channels );
		}
		else
		{
			$input_channels_list = "";
		}
		
		if( $input_poll_question )
		{
			$input_poll = base64_encode( $system -> stripthis( $input_poll_question ) ) . "|" . $input_poll_choice;
			
			for( $i = 1; $i < 21; $i++ )
			{
				$input_poll .= "|" . base64_encode( $system -> stripthis( $input_poll_options[ $i ] ) );
			}
		}
		else
		{
			$input_poll = "";
		}
		
		if( is_array( $input_fields ) )
		{
			$input_fields_encoded = base64_encode( $system -> stripthis( $input_fields[ 0 ] ) );
			
			for( $i = 1; $i < 24; $i++ )
			{
				$input_fields_encoded .= "|";
				
				if( isset( $input_fields[ $i ] ) )
				{
					$input_fields_encoded .= base64_encode( $system -> stripthis( $input_fields[ $i ] ) );
				}
			}
		}
		else
		{
			$input_fields_encoded = "";
		}
		
		$input_fields = "";
		
		if ( $input_blockcode )
		{
			if ( $input_url_tag )
			{
				$input_newsstory_story = preg_replace( "#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1[url]\\2[/url]", $input_newsstory_story );
				$input_newsstory_extendedstory = preg_replace( "#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1[url]\\2[/url]", $input_newsstory_extendedstory );	
			}
				
			if ( $input_url_get )
			{
				$input_newsstory_story = $system -> geturltitles( $input_newsstory_story );
				$input_newsstory_extendedstory = $system -> geturltitles( $input_newsstory_extendedstory );
			}
		}
		
		$input_newsstory_story_parsed = stripslashes( $input_newsstory_story );
		$input_newsstory_extendedstory_parsed = stripslashes( $input_newsstory_extendedstory );
		
		if( !$input_html )
		{
			$input_newsstory_story_parsed = $system -> dechomp( $input_newsstory_story_parsed );
			$input_newsstory_extendedstory_parsed = $system -> dechomp( $input_newsstory_extendedstory_parsed );
		}
		
		if( $input_smilies )
		{
			$input_newsstory_story_parsed = $system -> smilies( $input_newsstory_story_parsed );
			$input_newsstory_extendedstory_parsed = $system -> smilies( $input_newsstory_extendedstory_parsed );
		}
		
		if( $input_blockcode )
		{
			$input_newsstory_story_parsed = $system -> code( $input_newsstory_story_parsed );
			$input_newsstory_extendedstory_parsed = $system -> code( $input_newsstory_extendedstory_parsed );
			$input_newsstory_story_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=news&amp;action=attachments&amp;id=\\1\">\\2</a>", $input_newsstory_story_parsed );
			$input_newsstory_story_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=news&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_newsstory_story_parsed );
			$input_newsstory_story_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"" . $seo_url . "news" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\" title=\"" . $words_news[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"contentteller.php?ct=news&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_newsstory_story_parsed );
			$input_newsstory_extendedstory_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=news&amp;action=attachments&amp;id=\\1\">\\2</a>", $input_newsstory_extendedstory_parsed );
			$input_newsstory_extendedstory_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=news&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_newsstory_extendedstory_parsed );
			$input_newsstory_extendedstory_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"" . $seo_url . "news" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\" title=\"" . $words_news[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"contentteller.php?ct=news&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_newsstory_extendedstory_parsed );
		}
		
		$input_newsstory_story_parsed = $database -> dbescape( $input_newsstory_story_parsed );
		$input_newsstory_extendedstory_parsed = $database -> dbescape( $input_newsstory_extendedstory_parsed );
		
		if( $preferences[ 'news_start_expire_date' ] )
		{
			if( $input_now )
			{
				$input_startdate = date( "Y-m-d H:i:s", mktime() );
			}
			else
			{
				$input_startdate = date( "Y-m-d H:i:s", mktime( $input_hour, $input_minute, $input_second, $input_month, $input_day, $input_year ) );
			}
			
			$input_expiredate = date( "Y-m-d H:i:s", mktime( $input_expire_hour, $input_expire_minute, $input_expire_second, $input_expire_month, $input_expire_day, $input_expire_year ) );
		}
		
		if( $input_newsstory_tags )
		{
			$query = $database -> dbquery( "SELECT newsstory_tags FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE newsstory_id = '" . $input_zid . "'" );
			list( $newsstory_tags_old ) = $database -> dbrow( $query );
			$newsstory_tags_new = stripslashes( $input_newsstory_tags );
			
			if( $newsstory_tags_old != $newsstory_tags_new )
			{
				$newsstory_tags_old_array = explode( ",", $newsstory_tags_old );
				
				foreach( $newsstory_tags_old_array as $old_tag )
				{
					$query = $database -> dbquery( "SELECT newstag_id FROM " . DB_PREFIX . "esselbach_ct_newstags WHERE newstag_tag = '" . $database -> dbescape( $old_tag ) . "' AND newstag_website = '" . $input_website . "'" );
					
					if( $database -> dbrows( $query ) < 2 )
					{
						$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_newstags WHERE newstag_tag = '" . $database -> dbescape( $old_tag ) . "' AND newstag_website = '" . $input_website . "'" );
					}
					else
					{
						$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newstags SET newstag_count = newstag_count - 1, newstag_date = now() WHERE newstag_tag = '" . $database -> dbescape( $old_tag ) . "' AND newstag_website = '" . $input_website . "'" );
					}
				}
				
				$newsstory_tags_new_array = explode( ",", $newsstory_tags_new );
				
				foreach( $newsstory_tags_new_array as $new_tag )
				{
					$query = $database -> dbquery( "SELECT newstag_id FROM " . DB_PREFIX . "esselbach_ct_newstags WHERE newstag_tag = '" . $database -> dbescape( $new_tag ) . "' AND newstag_website = '" . $input_website . "'" );
					
					if( $database -> dbrows( $query ) )
					{
						$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newstags SET newstag_count = newstag_count + 1, newstag_date = now() WHERE newstag_tag = '" . $database -> dbescape( $new_tag ) . "' AND newstag_website = '" . $input_website . "'" );
					}
					else
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newstags (newstag_id, newstag_website, newstag_tag, newstag_seo, newstag_count, newstag_date) VALUES (NULL, '" . $input_website . "', '" . $database -> dbescape( $new_tag ) . "', '" . $system -> doseo( $database -> dbescape( $new_tag ) ) . "', '1', now())" );
					}
				}
			}
		}
		
		if( !$input_newsstory_seo )
		{
			$input_newsstory_seo = $input_newsstory_title;
		}
		
		$input_newsstory_seo = $system -> doseo( $input_newsstory_seo );
		$query = $database -> dbquery( "SELECT COUNT(newsstory_id) FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE newsstory_seo = '" . $input_newsstory_seo . "'" );
		list( $seo_stories ) = $database -> dbrow( $query );
		
		if( $seo_stories > 1 )
		{
			$input_newsstory_seo .= "_" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
		}
		
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newsstories SET newsstory_website = '" . $input_website . "', newsstory_channels = '" . $input_channels_list . "', newsstory_author = '" . $login_username . "', newsstory_title = '" . $input_newsstory_title . "', newsstory_seo = '" . $input_newsstory_seo . "', newsstory_source = '" . $input_newsstory_source . "', newsstory_sourceid = '" . $input_newsstory_sourceid . "', newsstory_rawstory = '" . $input_newsstory_story . "', newsstory_story = '" . $input_newsstory_story_parsed . "', newsstory_rawextendedstory = '" . $input_newsstory_extendedstory . "', newsstory_extendedstory = '" . $input_newsstory_extendedstory_parsed . "', newsstory_link = '" . $input_newsstory_link . "', newsstory_description = '" . $input_newsstory_description . "', newsstory_keywords = '" . $input_newsstory_keywords . "', newsstory_tags = '" . $input_newsstory_tags . "', newsstory_teaser = '" . $input_teaserimage . "', newsstory_allowcomments = '" . $input_allow_comments . "', newsstory_frontpage = '" . $input_frontpage . "', newsstory_poll = '" . $input_poll . "', newsstory_fields = '" . $input_fields_encoded . "', newsstory_html = '" . $input_html . "', newsstory_smilies = '" . $input_smilies . "', newsstory_code = '" . $input_blockcode . "', newsstory_status = '" . $input_status . "', newsstory_password = '" . $input_password . "', newsstory_sticky = '" . $input_top . "', newsstory_editip = '" . $ipaddr . "', newsstory_editadmin = '" . $login_username . "' WHERE newsstory_id = '" . $input_zid . "'" );
		
		if ( $input_bump )
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newsstories SET newsstory_date = now() WHERE newsstory_id = '" . $input_zid . "'" );			
		}
		
		if( $preferences[ 'news_start_expire_date' ] )
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newsstories SET newsstory_startdate = '" . $input_startdate . "', newsstory_expiredate = '" . $input_expiredate . "', newsstory_neverexpire = '" . $input_expire_never . "' WHERE newsstory_id = '" . $input_zid . "'" );
		}
		
		$html -> login( $words_news[ 'EDIT_STORY' ], $words_news[ 'STORY_CHANGED' ], "index.php?action=managestories" );
	}
}
?>